﻿// (C) Copyright 2002-2005 by Autodesk, Inc. 
// 
// Permission to use, copy, modify, and distribute this software in 
// object code form for any purpose and without fee is hereby granted, 
// provided that the above copyright notice appears in all copies and 
// that both that copyright notice and the limited warranty and 
// restricted rights notice below appear in all supporting 
// documentation. 
// 
// AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS. 
// AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF 
// MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE. AUTODESK, INC. 
// DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE 
// UNINTERRUPTED OR ERROR FREE. 
// 
// Use, duplication, or disclosure by the U.S. Government is subject to 
// restrictions set forth in FAR 52.227-19 (Commercial Computer 
// Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii) 
// (Rights in Technical Data and Computer Software), as applicable. 

using Autodesk.AutoCAD.Runtime;
using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.EditorInput;


public class adskClass
{

    [CommandMethod("addAnEnt")]
    public void AddAnEnt()
    {

        // Получаем объект редактора, чтобы иметь возможность ввода
        Editor ed = Application.DocumentManager.MdiActiveDocument.Editor;

        // Определим тип примитива, который мы хотим создать
        PromptKeywordOptions getWhichEntityOptions = new PromptKeywordOptions("Which entity do you want to create? [Circle/Block] : ", "Circle Block");
        // Теперь введем его
        PromptResult getWhichEntityResult = ed.GetKeywords(getWhichEntityOptions);
        // Если OK
        if ((getWhichEntityResult.Status == PromptStatus.OK))
        {

            // Проверим что требуется
            switch (getWhichEntityResult.StringResult)
            {

                case "Circle":

                    // Укажем точку центра окружности
                    PromptPointOptions getPointOptions = new PromptPointOptions("Pick Center Point : ");
                    PromptPointResult getPointResult = ed.GetPoint(getPointOptions);
                    // Если OK
                    if ((getPointResult.Status == PromptStatus.OK))
                    {

                        // Получаем радиус
                        PromptDistanceOptions getRadiusOptions = new PromptDistanceOptions("Pick Radius : ");
                        // Установим в качестве базовой точки центр окружности (точку, которую только что указали) 
                        getRadiusOptions.BasePoint = getPointResult.Value;
                        // теперь укажем механизму ввода использовать базовую точку! 
                        getRadiusOptions.UseBasePoint = true;
                        // теперь получаем радиус
                        PromptDoubleResult getRadiusResult = ed.GetDistance(getRadiusOptions);
                        // Если всё OK
                        if ((getRadiusResult.Status == PromptStatus.OK))
                        {

                            // Начало Lab3. Создадим окружность или описание блока и вставку блока 
                            // 1. Объявим переменную класса Database и присвоим ей значение 
                            // используя свойство Document.Database объекта класса Editor, созданного выше. (ed) 
                            // Заметка: Добавим пространство имён Autodesk.AutoCAD.DatabaseServices – пространство имён для Database 
                            // и Transaction, используя ключевое слово using (перед объявлением класса) 

                            // 2. Объявим переменную типа Transaction; создаём её используя 
                            // метод TransactionManager.StartTransaction объекта Database,
                            // созданного на предыдущем шагу.

                            // 3. Добавим блок try/catch/finally. Поместим try сразу после “}”
                            // в шаге 8. Поместим оператор catch сразу после него.
                            // Поместим  шаг 9 в блок catch. Поместим шаг 10 в блок finally.
                            // (Построим (Build) проект и исправим все ошибки).

                            // 4. Объявим переменную класса Circle и создадим её при помощи конструктора. 
                            // Используем свойство Value объекта PromptPointResult, созданного в Lab2 
                            // Lab2 в качестве первого параметра. В качестве второго параметра (нормаль) используем 
                            // Vector3d.ZAxis. Используем свойство Value объекта PromptDoubleResult 
                            // (созданного в Lab2) в качестве радиуса. 
                            // Заметка: Необходимо добавить пространство имён Autodesk.AutoCAD.Geometry для Vector3d.

                            // 5. Объявим переменную типа BlockTableRecord. Присвоим ей значение используя
                            // метод GetObject переменной типа Transaction созданной на шаге 2. 
                            // Используем свойство CurrentSpaceId переменной типа Database, созданной на шаге 1 
                            // в качестве первого параметра (ObjectId) В качестве второго параметра 
                            // используем OpenMode.ForWrite. Мы добавим окружность или в пространство модели
                            // (ModelSpace) или в пространство листа (PaperSpace)
                            // Определяет пространство CurrentSpaceId. 

                            // 6. Добавим  Circle к переменной BlockTableRecord созданной на шаге 5. Используем 
                            // Метод AppendEntity и передаём ему окружность, созданную на шаге 4. 

                            // 7. Сообщим транзакции о новом объекте для его «автозакрытия» 
                            // Для этой цели используется метод AddNewlyCreatedDBObject. Первый аргумент - окружность 
                            // Второй аргумент – true. 

                            // 8. Завершим транзакцию, вызвав её метод Commit. Если код дошел сюда - 
                            // значит всё работало правильно. 


                            // 9. Объявим переменную типа Exception для catch. 
                            // (добавим  "(Exception ex)" к блоку catch) 
                            // Используем метод WriteMessage редактора (ed), созданного в Lab2. 
                            // Используем "problem due to " + ex.Message в качестве параметра message. 
                            // Если произойдёт ошибка – детальная информация будет напечатана в командной строке AutoCAD 

                            // 10. Освободим транзакцию, созданную на шаге 2, вызвав её метод Dispose 
                            // Здесь мы окажемся независимо от того произошла ошибка или нет! 

                        }
                    }
                    break;
                case "Block":

                    // введем имя блока
                    PromptStringOptions blockNameOptions = new PromptStringOptions("Enter name of the Block to create : ");
                    // запретим использование пробелов в имени
                    blockNameOptions.AllowSpaces = false;
                    // получаем имя
                    PromptResult blockNameResult = ed.GetString(blockNameOptions);
                    // Если OK
                    if ((blockNameResult.Status == PromptStatus.OK))
                    {

                        // 11. Объявим переменную типа Database и присвоим ей значение равное
                        // свойству Document.Database переменной ed класса Editor


                        // 12. Объявим переменную типа Transaction и присвоим ей значение 
                        // возвращаемое методом TransactionManager.StartTransaction.

                        // 13. Добавим блок try/catch/finally. Перенесём “}”
                        // после шага 34. Поместим оператор catch после него.
                        // Заключим шаг 35 в блок catch. Заключим шаг 36 в блок finally.


                        // 14. Объявим переменную типа BlockTableRecord. Создаём её оператором new 

                        // 15. Установим имя BlockTableRecord. Используем свойство 
                        // StringResult переменной типа PromptResult (созданной в Lab2) 

                        // 16. Объявим переменную типа BlockTable. Присваиваем ей значение, которое возвращает метод 
                        // GetObject объекта транзакции. Используем свойство BlockTableId объекта 
                        // типа Database, созданного на шаге 11 в качестве первого параметра. 
                        // Второй параметр - OpenMode.ForRead. Мы открываем для чтения, чтобы проверить 
                        // нет ли еще блока с таким именем. 

                        // 17. Добавим оператор if. Проверяем есть ли блок с таким именем при помощи 
                        // метода Has переменной BlockTable, созданной на шаге 16. В качестве строки 
                        // parameter используем свойство StringResult объекта PromptResult, созданного выше в Lab2. 
                        // Проверим если результат равен false 
                        // Перенесём “}” после шага 34. 

                        // 18. Блока с таким именем еще нет, так что добавим его. 
                        // Сначала сделаем BlockTable открытой для записи. Чтобы это сделать - вызовем 
                        // метод UpgradeOpen() объекта типа BlockTable. (созданного на шаге 16) 


                        // 19. Добавим  BlockTableRecord, созданную на шаге 14. Используем метод Add 
                        // объекта BlockTable и передаём BlockTableRecord. 


                        // 20. Сообщаем транзакции о новом описании блока, чтобы она его «автозакрыла» 
                        // Используем метод AddNewlyCreatedDBObject транзакции. Первый аргумент 
                        // BlockTableRecord. Второй аргумент true. 


                        // 21. На следующих двух шагах добавим окружности к BlockTableRecord. 
                        // Объявим переменную класса Circle и создадим её оператором 
                        // new Circle. В качестве первого аргумента 
                        // new Point3d(0,0,0), в качестве второго аргумента Vector3d.ZAxis, 
                        // аргумент Radius равный 10. 


                        // 22. Добавим окружность к BlockTableRecord. 
                        // Используем метод AppendEntity, передаём окружность из шага 21 

                        // 23. Добавим другую окружность к BlockTableRecord 
                        // Объявим переменную класса Circle и создадим её при помощи оператора 
                        // new. В качестве первого аргумента new Point3d(20,10,0), второй аргумент Vector3d.ZAxis, 
                        // используем 10 в качестве аргумента Radius. 

                        // 24. Добавим вторую окружность к BlockTableRecord. 
                        // Используем метод AppendEntity и передаём окружность из шага 23 

                        // 25. Сообщим транзакции о новых объектах, чтобы она их «автозакрыла» 
                        // Вызовем для этого метод AddNewlyCreatedDBObject, передаём ему окружность 
                        // созданный на шаге 21. Делаем это снова для окружности, созданной на шаге 23 
                        // (используем true как второй аргумент). 

                        // 26. Теперь мы используем этот блок и добавим BlockReference к текущему пространству. 
                        // Сначала объявим переменную типа PromptPointOptions и создадим её при помощи 
                        // оператора new. В качестве параметра message используем "Pick insertion point of BlockRef : " 

                        // 27. Объявим переменную типа PromptPointResult. Используем метод GetPoint объекта 
                        // Editor созданного в Lab2 (ed). Передаём PromptPointOptions, созданную на шаге 26

                        // 28. Создаём оператор if и проверяем свойство Status переменной PromptPointResult. 
                        // Проверим равно ли оно PromptStatus.OK. 
                        // Поместим “}” после шага 30. 


                        // 29. Если мы попали сюда, значит метод GetPoint не удался. Вызовем метод 
                        // dispose объекта  Transaction, созданной на шаге 11. 

                        // 30. return 

                        // 31. Объявим переменную типа BlockReference. Создадим её при помощи оператора new 
                        // Используем метод Value объекта PromptPointResult в качестве аргумента Position. (Point3d) 
                        // Используем свойство ObjectId объекта BlockTableRecord, созданного на шаге 14 
                        // в качестве второго параметра. 

                        // 32. Получаем текущее пространство. (или ModelSpace или PaperSpace). 
                        // Объявим переменную типа BlockTableRecord, создаем её используя метод GetObject 
                        // транзакции, созданной на шаге 12. Используем свойство CurrentSpaceId 
                        // объекта Database, созданной на шаге 11. Открываем её на запись. (OpenMode.ForWrite) 

                        // 33. Используем метод AppendEntity объекта BlockTableRecord, созданного на шаге 32 
                        // и передаём BlockReference, созданный на шаге 31. 

                        // 34. Сообщим транзакции о новой вставке блока, чтобы транзакция его «автозакрыла» 
                        // Используем метод AddNewlyCreatedDBObject транзакции, созданной на шаге 12 
                        // Передаём ему BlockReference. Используем true в качестве второго параметра. 

                        // 35. Если мы попали сюда, значит всё в порядке! 
                        // Завершим транзакцию, вызвав метод Commit 


                        // 36. Объявим переменную типа Exception для catch. 
                        // (добавим "(Exception ex)" к ключевому слову catch) 
                        // Используем метод WriteMessage редактора (ed) созданного в Lab2. 
                        // Используем строку "a problem occurred because " + ex.Message в качестве . 
                        // параметра Message. Если ошибка произошла, её детали будут напечатаны 
                        // в командной строке AutoCAD. 

                        // 37. Освободим транзакцию, созданной на шаге 12, путём вызова метода Dispose 
                        // Это произойдет независимо от того произошли ли ошибки или нет 
                        // Это конец Lab3.
                        // Построим приложение (Build) и отладим путем загрузки в AutoCAD.
                        // (команда NETLOAD) и выполним команду addAnEnt.

                    } 
               break;
            }

        }
    }
} 