﻿
// (C) Copyright 2002-2005 by Autodesk, Inc. 
// 
// Permission to use, copy, modify, and distribute this software in 
// object code form for any purpose and without fee is hereby granted, 
// provided that the above copyright notice appears in all copies and 
// that both that copyright notice and the limited warranty and 
// restricted rights notice below appear in all supporting 
// documentation. 
// 
// AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS. 
// AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF 
// MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE. AUTODESK, INC. 
// DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE 
// UNINTERRUPTED OR ERROR FREE. 
// 
// Use, duplication, or disclosure by the U.S. Government is subject to 
// restrictions set forth in FAR 52.227-19 (Commercial Computer 
// Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii) 
// (Rights in Technical Data and Computer Software), as applicable. 

using Autodesk.AutoCAD.Runtime;
using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.EditorInput;
using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.Geometry;

using Autodesk.AutoCAD.Windows;



namespace Lab4
{
    public class adskClass
    {

        [CommandMethod("addAnEnt")]
        public void AddAnEnt()
        {

            // Получаем объект редактора, чтобы иметь возможность ввода
            Editor ed = Application.DocumentManager.MdiActiveDocument.Editor;

            // Определим тип примитива, который мы хотим создать
            PromptKeywordOptions getWhichEntityOptions = new PromptKeywordOptions("Which entity do you want to create? [Circle/Block] : ", "Circle Block");
            // Теперь введем его
            PromptResult getWhichEntityResult = ed.GetKeywords(getWhichEntityOptions);
            // Если OK
            if ((getWhichEntityResult.Status == PromptStatus.OK))
            {

                // Проверим что требуется
                switch (getWhichEntityResult.StringResult)
                {

                    case "Circle":

                        // Укажем точку центра окружности
                        PromptPointOptions getPointOptions = new PromptPointOptions("Pick Center Point : ");
                        PromptPointResult getPointResult = ed.GetPoint(getPointOptions);
                        // Если OK
                        if ((getPointResult.Status == PromptStatus.OK))
                        {

                            // Получаем радиус
                            PromptDistanceOptions getRadiusOptions = new PromptDistanceOptions("Pick Radius : ");
                            // Установим в качестве базовой точки центр окружности (точку, которую только что указали) 
                            getRadiusOptions.BasePoint = getPointResult.Value;
                            // теперь укажем механизму ввода использовать базовую точку! 
                            getRadiusOptions.UseBasePoint = true;
                            // теперь получаем радиус
                            PromptDoubleResult getRadiusResult = ed.GetDistance(getRadiusOptions);
                            // Если всё OK
                            if ((getRadiusResult.Status == PromptStatus.OK))
                            {
                                // Начало Lab3. Создадим окружность или описание блока и вставку блока 
                                // 1. Объявим переменную класса Database и присвоим ей значение 
                                // используя свойство Document.Database объекта класса Editor, созданного выше. (ed) 
                                // Заметка: Добавим пространство имён Autodesk.AutoCAD.DatabaseServices – пространство имён для Database 
                                // и Transaction, используя ключевое слово using (перед объявлением класса) 
                                Database dwg = ed.Document.Database;

                                // 2. Объявим переменную типа Transaction; создаём её используя 
                                // метод TransactionManager.StartTransaction объекта Database,
                                // созданного на предыдущем шагу.
                                Transaction trans = dwg.TransactionManager.StartTransaction();

                                // 3. Добавим блок try/catch/finally. Поместим try сразу после “}”
                                // в шаге 8. Поместим оператор catch сразу после него.
                                // Поместим  шаг 9 в блок catch. Поместим шаг 10 в блок finally.
                                // (Построим (Build) проект и исправим все ошибки).
                                try
                                {

                                    // 4. Объявим переменную класса Circle и создадим её при помощи конструктора. 
                                    // Используем свойство Value объекта PromptPointResult, созданного в Lab2 
                                    // Lab2 в качестве первого параметра. В качестве второго параметра (нормаль) используем 
                                    // Vector3d.ZAxis. Используем свойство Value объекта PromptDoubleResult 
                                    // (созданного в Lab2) в качестве радиуса. 
                                    // Заметка: Необходимо добавить пространство имён Autodesk.AutoCAD.Geometry для Vector3d.
                                    Circle circle = new Circle(getPointResult.Value, Vector3d.ZAxis, getRadiusResult.Value);

                                    // 5. Объявим переменную типа BlockTableRecord. Присвоим ей значение используя
                                    // метод GetObject переменной типа Transaction созданной на шаге 2. 
                                    // Используем свойство CurrentSpaceId переменной типа Database, созданной на шаге 1 
                                    // в качестве первого параметра (ObjectId) В качестве второго параметра 
                                    // используем OpenMode.ForWrite. Мы добавим окружность или в пространство модели
                                    // (ModelSpace) или в пространство листа (PaperSpace)
                                    // Определяет пространство CurrentSpaceId. 
                                    BlockTableRecord btr = (BlockTableRecord)trans.GetObject(dwg.CurrentSpaceId, OpenMode.ForWrite);

                                    // 6. Добавим  Circle к переменной BlockTableRecord созданной на шаге 5. Используем 
                                    // Метод AppendEntity и передаём ему окружность, созданную на шаге 4. 
                                    btr.AppendEntity(circle);

                                    // 7. Сообщим транзакции о новом объекте для его «автозакрытия» 
                                    // Для этой цели используется метод AddNewlyCreatedDBObject. Первый аргумент - окружность 
                                    // Второй аргумент – true. 
                                    trans.AddNewlyCreatedDBObject(circle, true);

                                    // 8. Завершим транзакцию, вызвав её метод Commit. Если код дошел сюда - 
                                    // значит всё работало правильно. 
                                    trans.Commit();
                                }
                                catch (Exception ex)
                                {
                                    // 9. Объявим переменную типа Exception для catch. 
                                    // (добавим  "(Exception ex)" к блоку catch) 
                                    // Используем метод WriteMessage редактора (ed), созданного в Lab2. 
                                    // Используем "problem due to " + ex.Message в качестве параметра message. 
                                    // Если произойдёт ошибка – детальная информация будет напечатана в командной строке AutoCAD 
                                    ed.WriteMessage("problem due to " + ex.Message);
                                }
                                finally
                                {
                                    // 10. Освободим транзакцию, созданную на шаге 2, вызвав её метод Dispose 
                                    // Здесь мы окажемся независимо от того произошла ошибка или нет! 
                                    trans.Dispose();
                                }
                            }
                        }
                        break;
                    case "Block":

                        // введем имя блока
                        PromptStringOptions blockNameOptions = new PromptStringOptions("Enter name of the Block to create : ");
                        // запретим использование пробелов в имени
                        blockNameOptions.AllowSpaces = false;
                        // получаем имя
                        PromptResult blockNameResult = ed.GetString(blockNameOptions);
                        // Если OK
                        if ((blockNameResult.Status == PromptStatus.OK))
                        {

                            // 11. Объявим переменную типа Database и присвоим ей значение равное
                            // свойству Document.Database переменной ed класса Editor
                            Database dwg = ed.Document.Database;

                            // 12. Объявим переменную типа Transaction и присвоим ей значение 
                            // возвращаемое методом TransactionManager.StartTransaction.
                            Transaction trans = (Transaction)dwg.TransactionManager.StartTransaction();

                            // 13. Добавим блок try/catch/finally. Перенесём “}”
                            // после шага 34. Поместим оператор catch после него.
                            // Заключим шаг 35 в блок catch. Заключим шаг 36 в блок finally.
                            try
                            {

                                // 14. Объявим переменную типа BlockTableRecord. Создаём её оператором new 
                                BlockTableRecord newBlockDef = new BlockTableRecord();

                                // 15. Установим имя BlockTableRecord. Используем свойство 
                                // StringResult переменной типа PromptResult (созданной в Lab2) 
                                newBlockDef.Name = blockNameResult.StringResult;

                                // 16. Объявим переменную типа BlockTable. Присваиваем ей значение, которое возвращает метод 
                                // GetObject объекта транзакции. Используем свойство BlockTableId объекта 
                                // типа Database, созданного на шаге 11 в качестве первого параметра. 
                                // Второй параметр - OpenMode.ForRead. Мы открываем для чтения, чтобы проверить 
                                // нет ли еще блока с таким именем. 
                                BlockTable blockTable = (BlockTable)trans.GetObject(dwg.BlockTableId, OpenMode.ForRead);

                                // 17. Добавим оператор if. Проверяем есть ли блок с таким именем при помощи 
                                // метода Has переменной BlockTable, созданной на шаге 16. В качестве строки 
                                // parameter используем свойство StringResult объекта PromptResult, созданного выше в Lab2. 
                                // Проверим если результат равен false 
                                // Перенесём “}” после шага 34. 
                                if ((blockTable.Has(blockNameResult.StringResult) == false))
                                {

                                    // 18. Блока с таким именем еще нет, так что добавим его. 
                                    // Сначала сделаем BlockTable открытой для записи. Чтобы это сделать - вызовем 
                                    // метод UpgradeOpen() объекта типа BlockTable. (созданного на шаге 16) 
                                    blockTable.UpgradeOpen();

                                    // 19. Добавим  BlockTableRecord, созданную на шаге 14. Используем метод Add 
                                    // объекта BlockTable и передаём BlockTableRecord. 
                                    blockTable.Add(newBlockDef);

                                    // 20. Сообщаем транзакции о новом описании блока, чтобы она его «автозакрыла» 
                                    // Используем метод AddNewlyCreatedDBObject транзакции. Первый аргумент 
                                    // BlockTableRecord. Второй аргумент true. 
                                    trans.AddNewlyCreatedDBObject(newBlockDef, true);

                                    // 21. На следующих двух шагах добавим окружности к BlockTableRecord. 
                                    // Объявим переменную класса Circle и создадим её оператором 
                                    // new Circle. В качестве первого аргумента 
                                    // new Point3d(0,0,0), в качестве второго аргумента Vector3d.ZAxis, 
                                    // аргумент Radius равный 10. 
                                    Circle circle1 = new Circle(new Point3d(0, 0, 0), Vector3d.ZAxis, 10);

                                    // 22. Добавим окружность к BlockTableRecord. 
                                    // Используем метод AppendEntity, передаём окружность из шага 21 
                                    newBlockDef.AppendEntity(circle1);

                                    // 23. Добавим другую окружность к BlockTableRecord 
                                    // Объявим переменную класса Circle и создадим её при помощи оператора 
                                    // new. В качестве первого аргумента new Point3d(20,10,0), второй аргумент Vector3d.ZAxis, 
                                    // используем 10 в качестве аргумента Radius. 
                                    Circle circle2 = new Circle(new Point3d(20, 10, 0), Vector3d.ZAxis, 10);

                                    // 24. Добавим вторую окружность к BlockTableRecord. 
                                    // Используем метод AppendEntity и передаём окружность из шага 23 
                                    newBlockDef.AppendEntity(circle2);

                                    // 25. Сообщим транзакции о новых объектах, чтобы она их «автозакрыла» 
                                    // Вызовем для этого метод AddNewlyCreatedDBObject, передаём ему окружность 
                                    // созданный на шаге 21. Делаем это снова для окружности, созданной на шаге 23 
                                    // (используем true как второй аргумент). 

                                    trans.AddNewlyCreatedDBObject(circle1, true);
                                    trans.AddNewlyCreatedDBObject(circle2, true);


                                    // 26. Теперь мы используем этот блок и добавим BlockReference к текущему пространству. 
                                    // Сначала объявим переменную типа PromptPointOptions и создадим её при помощи 
                                    // оператора new. В качестве параметра message используем "Pick insertion point of BlockRef : " 
                                    PromptPointOptions blockRefPointOptions = new PromptPointOptions("Pick insertion point of BlockRef : ");

                                    // 27. Объявим переменную типа PromptPointResult. Используем метод GetPoint объекта 
                                    // Editor созданного в Lab2 (ed). Передаём PromptPointOptions, созданную на шаге 26
                                    PromptPointResult blockRefPointResult = ed.GetPoint(blockRefPointOptions);

                                    // 28. Создаём оператор if и проверяем свойство Status переменной PromptPointResult. 
                                    // Проверим равно ли оно PromptStatus.OK. 
                                    // Поместим “}” после шага 30. 
                                    if ((blockRefPointResult.Status != PromptStatus.OK))
                                    {

                                        // 29. Если мы попали сюда, значит метод GetPoint не удался. Вызовем метод 
                                        // dispose объекта  Transaction, созданной на шаге 11. 

                                        trans.Dispose();
                                        // 30. return 
                                        return;
                                    }

                                    // 31. Объявим переменную типа BlockReference. Создадим её при помощи оператора new 
                                    // Используем метод Value объекта PromptPointResult в качестве аргумента Position. (Point3d) 
                                    // Используем свойство ObjectId объекта BlockTableRecord, созданного на шаге 14 
                                    // в качестве второго параметра. 
                                    BlockReference blockRef = new BlockReference(blockRefPointResult.Value, newBlockDef.ObjectId);

                                    // 32. Получаем текущее пространство. (или ModelSpace или PaperSpace). 
                                    // Объявим переменную типа BlockTableRecord, создаем её используя метод GetObject 
                                    // транзакции, созданной на шаге 12. Используем свойство CurrentSpaceId 
                                    // объекта Database, созданной на шаге 11. Открываем её на запись. (OpenMode.ForWrite) 
                                    BlockTableRecord curSpace = (BlockTableRecord)trans.GetObject(dwg.CurrentSpaceId, OpenMode.ForWrite);

                                    // 33. Используем метод AppendEntity объекта BlockTableRecord, созданного на шаге 32 
                                    // и передаём BlockReference, созданный на шаге 31. 

                                    curSpace.AppendEntity(blockRef);

                                    // 34. Сообщим транзакции о новой вставке блока, чтобы транзакция его «автозакрыла» 
                                    // Используем метод AddNewlyCreatedDBObject транзакции, созданной на шаге 12 
                                    // Передаём ему BlockReference. Используем true в качестве второго параметра. 
                                    trans.AddNewlyCreatedDBObject(blockRef, true);

                                    // 35. Если мы попали сюда, значит всё в порядке! 
                                    // Завершим транзакцию, вызвав метод Commit 
                                    trans.Commit();
                                }
                            }
                            catch (Exception ex)
                            {
                                // 36. Объявим переменную типа Exception для catch. 
                                // (добавим "(Exception ex)" к ключевому слову catch) 
                                // Используем метод WriteMessage редактора (ed) созданного в Lab2. 
                                // Используем строку "a problem occurred because " + ex.Message в качестве . 
                                // параметра Message. Если ошибка произошла, её детали будут напечатаны 
                                // в командной строке AutoCAD. 
                                ed.WriteMessage("a problem occurred because " + ex.Message);
                            }
                            finally
                            {
                                // 37. Освободим транзакцию, созданной на шаге 12, путём вызова метода Dispose 
                                // Это произойдет независимо от того произошли ли ошибки или нет 
                                // Это конец Lab3.
                                // Построим приложение (Build) и отладим путем загрузки в AutoCAD.
                                // (команда NETLOAD) и выполним команду addAnEnt.
                                trans.Dispose();
                            }
                        }
                        break;
                }

            }
        }
        // 1. Используем ссылку на PresentationCore. (Используем вкладку .NET 
        // в диалоге Add Reference. Это необходимо для PaletteSet 
        // которую мы объявим на шаге 3. 

        // 2. Используем директиву using для пространства имён Autodesk.AutoCAD.Windows 

        // 3. Объявим переменную PaletteSet (глобальную) как PaletteSet. (она будет 
        // создана только один раз). Добавим это объявление после функции AddAnEnt из Lab 3. 

        // 4. Объявим переменную типа UserControl1. Этот контрол создан 
        // перед шагами. Этот контрол будет размещен на 
        // PaletteSet объявленной на шаге 3. Необходимо использовать 
        // пространство имён UserControl1 в объявлении. (Lab4)

        // 5. Добавим новую команду с именем “palette”. Используем атрибут
        // CommandMethod и создаём функцию, которая будет выполнятся при вызове команды
        // Заметка: Поместите “}” после шага 10. 

        // 6. Добавим оператор "if" и проверим, равна ли переменная типа 
        // PaletteSet, объявленная на шаге 3, null. Она будет 
        // null при первом запуске команды. 
        // Заметка: Поместите “}” после шага 9. 

        // 7. Если PaletteSet равна null – создадим новый PaletteSet, 
        // с уникальным GUID. Используем оператор new. Параметр Name 
        // сделаем "My Palette". В качестве параметра ToolID генерируем новый GUID. 
        // В меню Tools выберите "Create Guid". В диалоге "Create GUID" 
        // выберите "Registry Format" Выберите новый GUID и скопируйте. 
        // Вставьте GUID для использования как новый System.Guid. 
        // Замените фигурные скобки на двойные кавычки (параметр для GUID
        // строковый)

        // 8. Создаём переменную UserControl1, объявленную на шаге 4 
        // Используем оператор new. (new UserControl1 – необходимо 
        // указать и пространство имён) 
        // Этот контрол содержит TreeView контрол. 

        // 9. Добавим UserControl к PaletteSet. Используем метод Add method 
        // объекта PaletteSet, созданного на шаге 7. Используем "Palette1" 
        // в качестве параметра имени и, созданный на шаге 8, 
        // контрол в качестве второго параметра

        // 10. Покажем paletteset, установив её свойству Visible 
        // значение true. При втором запуске команды 
        // только этот код будет выполнен. 

        // 11. Добавим команду с именем "addDBEvents. Используем атрибут CommandMethod 
        // и добавим функцию, которая выполнит код, когда команда запущена 
        // Заметка: Поместите “}” после шага 20 

        // 12. Используем оператор if чтобы проверить равна ли null 
        // переменная palette, созданная на шаге 4. 
        // Заметка: Поместите “}” после шага 15 

        // 13. Объявим и инициализируем объект типа Editor. Используем 
        // свойство Editor объекта Application.DocumentManager.MdiActiveDocument 

        // 14. Используем метод WriteMessage переменной типа Editor, 
        // созданной на шаге 13. Используем в качестве параметра message 
        // "\n" + "Please call the 'palette' command first" 

        // 15. return

        // 16. Объявим переменную типа Database и присвоим ей значение 
        // свойство Database объекта 
        // Application.DocumentManager.MdiActiveDocument 


        // 17. Подпишемся на событие ObjectAppended. Используем событие ObjectAppended
        // переменной типа Database, созданной на шаге 16. Используем
        // оператор += и оператор new для создания нового ObjectEventHandler.
        // В качестве параметра цели используется имя функции, 
        // которую мы создадим на шаге 21.
        // (callback_ObjectAppended).


        // 18. Подпишемся на событие ObjectErased. Используем событие ObjectErased
        // переменной типа Database, созданной на шаге 16. Используем
        // оператор += и оператор new для создания нового ObjectErasedEventHandler. 
        // В качестве параметра цели используется
        // имя функции, которую мы создадим на шаге 24.
        // (callback_ObjectErased).

        // 19. Подписываемся на событие ObjectReappended. Используем событие ObjectReappended
        // переменной типа Database, созданной на шаге 16. Используем
        // оператор += и оператор new для создания нового ObjectEventHandler. 
        // В качестве параметра цели используется
        // имя функции, которую мы создадим на шаге 32.
        // (callback_ObjectReappended).

        // 20. Подписываемся на событие ObjectUnappended. Используем событие ObjectUnappended
        // переменной типа Database, созданной на шаге 16. Используем
        // оператор += и оператор new для создания нового ObjectEventHandler. 
        // В качестве параметра цели используется
        // имя функции, которую мы создадим на шаге 35.
        // (callback_ObjectUnappended).

        // 21. Создадим частную (private) функцию с именем callback_ObjectAppended. (возвращающую void)
        // Эта функция будет вызываться, когда объекты будут добавляться 
        // к Database (Имя должно совпадать с именем параметра Delegate из шага 17
        // Первый параметр – объект (object) (зададим ему имя sender)
        // Второй параметр типа ObjectEventArgs (зададим ему имя e)
        // Заметка: Поместим “}” после шага 23 

        // 22. Объявим переменную типа TreeNode (System.Windows.Forms.TreeNode). 
        // Заметка: Можно сократить текст программы, если использовать директиву using с именем пространства имён. 
        // Создадим её (переменную) используя метод Add свойства Nodes объекта TreeView в 
        // UserControl(), созданного на шаге 4. Используем параметр 
        // ObjectEventArgs, переданный в функцию в качестве строкового 
        // параметра и используем тип DBObject. (e.DBObject.GetType().ToString()) 

        // 23. Присваиваем свойство Tag для node, созданного на шаге 22 
        // равное ObjectId добавляемого объект 
        // Это позволит нам записать его ObjectId для распознавания в других событиях 
        // Используем e.DBObject.ObjectId.ToString() 

        // 24. Создадим частную (private) функцию с именем callback_ObjectErased. (возвращающую void)
        // Эта функция будет вызываться, когда объекты будут удалятся из 
        // Database (Имя должно совпадать с именем параметра Delegate из шага 18
        // Первый параметр – объект (object) (зададим ему имя sender)
        // Второй параметр типа ObjectErasedEventArgs (зададим ему имя e)
        // Заметка: Поместим “}” после шага 32 

        // 25. Используем оператор "if else"  и проверяем свойство Erased объекта 
        // ObjectErasedEventArgs переданного в функцию. (e.Erased) 
        // Заметка: Поместим “}” и оператор "else" перед шагом 30. 
        // Поместим “}” для "else" после шага 31 

        // 26. Будем искать объект в контроле TreeView, чтобы его оттуда удалить. 
        // Запишем оператор foreach. Используем node в качестве имени элемента цикла
        // типа System.Windows.Forms.Treenode. Параметр коллекции – свойство Nodes в TreeView. 
        // (myPalette.treeView1.Nodes) 
        // Заметка: Поместим “}” после шага 29 

        // 27. Используем оператор "if". Проверим, что свойств Tag объекта node равен the ObjectId 
        // удалённого объекта. Используем свойство DBObject объекта 
        // ObjectErasedEventArgs, переданного в событие. (e.DBObject.ObjectId.ToString()) 
        // Заметка: Поместите “}” над “}” цикла 

        // 28. Удалим node вызовом метода Remove. (Примитив был удалён из чертежа) 

        // 29. Завершим цикл оператором break. 

        // 30. Если мы попали сюда, то объект был восстановлен (unerased). (e.Erased равно false) 
        // Объявим переменную типа System.Windows.Forms.TreeNode с именем newNode
        // Создаём её методом Add коллекции Nodes объекта TreeView, созданного ранее. 
        // Используем тип объекта в качестве параметра. 
        // e.DBObject.GetType().ToString() 

        // 31. Присваиваем свойству Tag объекта newNode, созданного на шаге 30, равного ObjectId 
        // восстановленного объекта. Это позволит записать ObjectId для распознавания 
        // в других событиях. Используем e.DBObject.ObjectId.ToString() 

        // 32. Создаём частную функцию с именем callback_ObjectReappended. Эта функция 
        // будет вызываться, когда объект повторно добавляется (ReAppended) к базе. 
        // (Имя должно совпадать с именем параметра Delegate на шаге 19). 
        // Первый параметр - объект. (Используем имя sender). Второй параметр 
        // ObjectEventArgs. (используем e в качестве его имени) 
        // Заметка: Поместим “}” после шага 34 

        // 33. Добавим имя класса объекта к контролу TreeView 
        // Объявим переменную типа TreeNode. (System.Windows.Forms.TreeNode). 
        // Присваиваем ей значение используя метод Add свойства Nodes контрола TreeView на UserForm1, 
        // создано на шаге 4. Используем ObjectEventArgs, переданный в метод в качестве
        // строкового параметра parameter и используем тип DBObject. 
        //(e.DBObject.GetType().ToString()) 

        // 34. Записываем его ID для дальнейшего опознания 
        // Присваиваем свойству Tag для node, созданного на шаге 33, значение равное ObjectId
        // восстановленного объекта. Это позволит нам записать его ObjectId для распознавания 
        // в других событиях. Используем e.DBObject.ObjectId.ToString() 

        // 35. Создаем частную функцию с именем callback_ObjectUnappended. (возвращающую void) Эта функция
        // будет вызываться, когда объект исключается (UnAppended) из базы. 
        // (Имя должно быть таким же, как имя параметра Delegate на шаге 20). 
        // Первый параметр - объект. (Используем имя sender). 
        // Второй параметр - ObjectEventArgs. (Используем имя e) 
        // Заметка: Поместим “}” после шага 39 

        // 36. Здесь мы поищем объект в контроле TreeView, чтобы его удалить. 
        // Создаём оператор foreach. В качестве элемента цикла используем имя node и тип 
        // System.Windows.Forms.TreeNode. Параметр коллекция - свойство Nodes объекта TreeView. 
        // (myPalette.treeView1.Nodes) 
        // Заметка: Поместим “}” после шага 39  

        // 37. Используем оператор "if" и сравниваем node.Tag с ObjectId. 
        // (Используем e.DBObject.ObjectId.ToString) 
        // Заметка: Поместим “}” после шага 39  

        // 38. Если мы попали сюда, тогда мы нашли node для unappended объекта. 
        // Вызываем метод Remove для node. 

        // 39. Выходим из цикла при помощи break.
    }
}
