﻿' (C) Copyright 2010 by Autodesk, Inc. 
'
Imports System
Imports Autodesk.AutoCAD.Runtime
Imports Autodesk.AutoCAD.ApplicationServices
Imports Autodesk.AutoCAD.DatabaseServices
Imports Autodesk.AutoCAD.Geometry
Imports Autodesk.AutoCAD.EditorInput

' This line is not mandatory, but improves loading performances
<Assembly: CommandClass(GetType(Lab2.MyCommands))> 

Namespace Lab2

    ' This class is instantiated by AutoCAD for each document when
    ' a command is called by the user the first time in the context
    ' of a given document. In other words, non static data in this class
    ' is implicitly per-document!
    Public Class MyCommands

        ' The CommandMethod attribute can be applied to any public  member 
        ' function of any public class.
        ' The function should take no arguments and return nothing.
        ' If the method is an instance member then the enclosing class is 
        ' instantiated for each document. If the member is a static member then
        ' the enclosing class is NOT instantiated.
        '
        ' NOTE: CommandMethod has overloads where you can provide helpid and
        ' context menu.

        ' Modal Command with localized name
        ' AutoCAD will search for a resource string with Id "MyCommandLocal" in the 
        ' same namespace as this command class. 
        ' If a resource string is not found, then the string "MyLocalCommand" is used 
        ' as the localized command name.
        ' To view/edit the resx file defining the resource strings for this command, 
        ' * click the 'Show All Files' button in the Solution Explorer;
        ' * expand the tree node for myCommands.vb;
        ' * and double click on myCommands.resx
        <CommandMethod("MyGroup", "MyCommand", "MyCommandLocal", CommandFlags.Modal)> _
        Public Sub MyCommand() ' This method can have any name
            ' Put your command code here
        End Sub

        ' Modal Command with pickfirst selection
        <CommandMethod("MyGroup", "MyPickFirst", "MyPickFirstLocal", CommandFlags.Modal + CommandFlags.UsePickSet)> _
        Public Sub MyPickFirst() ' This method can have any name
            Dim result As PromptSelectionResult = Application.DocumentManager.MdiActiveDocument.Editor.GetSelection()
            If (result.Status = PromptStatus.OK) Then
                ' There are selected entities
                ' Put your command using pickfirst set code here
            Else
                ' There are no selected entities
                ' Put your command code here
            End If
        End Sub

        ' Application Session Command with localized name
        <CommandMethod("MyGroup", "MySessionCmd", "MySessionCmdLocal", CommandFlags.Modal + CommandFlags.Session)> _
        Public Sub MySessionCmd() ' This method can have any name
            ' Put your command code here
        End Sub

        ' Начало Lab2

        ' 1. Добавим команду с именем addAnEnt. Воспользуемся атрибутом  CommandMethod и 
        ' Public Sub. (используем символ продолжения строки " _")
        ' Заметка: Поместите End Sub после шага 19.

        ' 2. Объявим переменную типа Editor с именем ed. Присвоим ей значение равное
        ' свойству Editor объекта Application.DocumentManager.MdiActiveDocument

        ' 3. Объявим переменную типа PromptKeywordOptions и присвоим ей значение при помощи
        ' New PromptKeywordOptions. Используем строку подобную следующей для
        ' строки параметров messageAndKeywords.
        ' "Which entity do you want to create? [Circle/Block] : ", "Circle Block"

        ' 4. Объявим переменную типа PromptResult. Воспользуемся методом GetKeywords переменной ed, созданной на шаге 1
        ' Передадим методу параметр типа PromptKeywordOptions созданный на шаге 2.
        ' Присвоим переменной типа PromptResult значение, которое возвращает метод GetKeywords.

        ' 5. Добавим оператор If Then для проверки свойства Status переменной типа PromptResult
        ' созданного на шаге 4. Воспользуемся перечислением PromptStatus для этой проверки.
        ' (смотрим равен ли он PromptStatus.OK) 
        ' Заметка. Перенесем оператор End If после шага 19. 


        ' 6. PromptStatus равен ok. Теперь запишем оператор Select Case. В качестве проверяемого значения используем
        ' Свойство StringResult переменной класса PromptResult используемой выше
        ' Заметка: Перенесите оператор End Select после шага 19.
        ' (Перед оператором End If)

        ' 7. Используем "Circle" в качестве варианта. (Если StringResult равно "Circle")
        ' (На шаге 15 мы добавим вариант для "Block").

        ' 8. Мы хотим запросить у пользователя центр окружности. Объявим
        ' переменную типа PromptPointOptions и присвоим ей значение равное
        ' New PromptPointOptions. Используем строку "Pick Center Point : " в 
        ' качестве параметра message 

        ' 9. Объявим переменную типа PromptPointResult. 
        ' Воспользуемся методом GetPoint объекта ed класса Editor и шага 2
        ' Передадим переменную PromptPointOptions созданную на шаге 8
        ' Присвоим переменной PromptPointResult значение,
        ' которое возвращает метод GetPoint method.

        ' 10. Добавим оператор If Then для проверки свойства Status переменной типа PromptPointResult 
        ' созданной на шаге 9. Используем перечисление PromptStatus для проверки. 
        ' (убедимся, что всё в порядке)
        ' Заметка: Перенесём оператор End If прямо перед шагом 15. 


        ' 11. Теперь мы можем спросить у пользователя радиус окружности
        ' Объявим переменную типа  PromptDistanceOptions. Присвоим ей значение равное
        ' New PromptDistanceOptions. 
        ' Используем строку "Pick Radius : " в качестве параметра message. 

        ' 12.  Мы хотим воспользоваться точкой, полученной на шаге 9 
        ' в качестве базовой точки для метода GetDistance. Для этого воспользуемся
        ' свойством BasePoint переменной класса PromptDistanceOptions,
        ' созданной на предыдущем шаге. Присвоим свойству BasePoint значение равное свойству Value
        ' переменной PromptPointResult созданной на шаге 9. 


        ' 13. Нам нужно сообщить механизму ввода, что действительно нужно использовать базовую точку.
        ' Чтобы сделать это, установим свойство UseBasePoint переменной типа 
        ' PromptDistanceOptions, созданной на шаге 11, в True. 


        ' 14. Получим радиус окружности. Объявим переменную класса PromptDoubleResult.
        ' Присвоим ей значение равное результату вызова метода GetDistance переменной типа Editor, созданной на шаге 2
        ' Передадим переменную PromptDistanceOptions созданной на шаге 11 и
        ' модифицированную на предыдущем шаге. 

        ' 15. Добавим инструкцию Case для строки "Block"


        ' 16. Теперь мы хотим спросить у пользователя имя блока. Объявим
        ' переменную типа PromptStringOptions и присвоим ей значение
        ' New PromptStringOptions. Используем строку "Enter name of the Block to create : "
        ' в качестве параметра message.

        ' 17. Пробелы недопустимы в качестве имени блока, так что запретим их.
        ' Для этого установим свойство AllowSpaces переменной типа
        ' PromptStringOptions, созданной на шаге 16 в False.

        ' 18. Получим указанное пользователем имя. Объявим переменную типа PromptResult
        ' и присвоим ей значение, которое возвращает метод GetString объекта ed класса Editor
        ' созданной на шаге 2. Передадим значение переменной типа PromptStringOptions созданной на шаге 16.

        ' 19. Построим проект (компилируем). Установим точку останова (break point).
        ' Воспользуемся командой NETLOAD и выполним команду AddAnEnt.
        ' Пошагово выполним код и исправим ошибки.
        ' Не забудьте запустить команду и протестировать код и для круга и для блока.


        ' LispFunction is similar to CommandMethod but it creates a lisp 
        ' callable function. Many return types are supported not just string
        ' or integer.
        <LispFunction("MyLispFunction", "MyLispFunctionLocal")> _
        Public Function MyLispFunction(ByVal args As ResultBuffer) ' This method can have any name
            ' Put your command code here

            ' Return a value to the AutoCAD Lisp Interpreter
            Return 1
        End Function

    End Class

End Namespace