﻿' (C) Copyright 2002-2005 by Autodesk, Inc.
'
' Permission to use, copy, modify, and distribute this software in
' object code form for any purpose and without fee is hereby granted,
' provided that the above copyright notice appears in all copies and
' that both that copyright notice and the limited warranty and
' restricted rights notice below appear in all supporting
' documentation.
'
' AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS.
' AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
' MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC.
' DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
' UNINTERRUPTED OR ERROR FREE.
'
' Use, duplication, or disclosure by the U.S. Government is subject to
' restrictions set forth in FAR 52.227-19 (Commercial Computer
' Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
' (Rights in Technical Data and Computer Software), as applicable.
'



Imports Autodesk.AutoCAD.Runtime
Imports Autodesk.AutoCAD.ApplicationServices
Imports Autodesk.AutoCAD.EditorInput
Imports Autodesk.AutoCAD.DatabaseServices
Imports Autodesk.AutoCAD.Geometry
Imports System.Windows

Imports Autodesk.AutoCAD.Windows



' Начало Lab8
' Чтобы выполнить инициализацию при загрузке, приложение AutoCAD .NET должно
' реализовать определенный класс, чтобы достичь этого.  Класс должен реализовывать
' интерфейс IExtensionApplication, и объявлять атрибут уровня сборки,
' который сообщает о том, что имеется класс типа ExtensionApplication.
' Класс может обрабатывать события загрузки и выгрузки.
' В этой лабораторной мы добавим контекстное меню и добавим вкладку в диалог Настройки (OPTIONS)
' Мы также обеспечим функциональность Drag & Drop для запуска команды при перетаскивании
' метки из палитры в окно редактора AutoCAD

Public Class adskClass

    ' 1. Модифицируем класс asdkClass1 чтобы реализовать интерфейс IExtensionApplication.
    ' Заметка: Visual Studio автоматически добавляет набор требуемых методов
    ' Initialize() и Terminate(). Ищите эти методы после остальных существующих.
    ' Скопируйте и вставьте шаги с 23 по 37 внутрь процедуры Initialize и шаг 24
    ' внутрь процедуры Terminate
    ' Так же добавим атрибут путем раскомментаривания следующей строки кода. (должна быть вне класса)
    ' ' Это строка не обязательна, но повышает скорость загрузки
    ' <Assembly: ExtensionApplication(GetType(adskClass))>

    ' 2. Объявим переменную класса ContextMenuExtension. Она будет создана на шаге 6

    ' (Этот класс - член пространства имён Autodesk.AutoCAD.Windows).


    ' 3. Создадим частную процедуру с именем AddContextMenu.
    ' Заметка: Поместим End Sub после шага 12.


    ' 4. Объявим переменную класса Editor. Создадим её присвоим ей значение,
    ' которое возвращает свойство Editor объекта
    ' Application.DocumentManager.MdiActiveDocument


    ' 5. Добавим блок Try/Catch/Finally.
    ' Заметка: поместим Catch после шага 11.
    ' Пусть он использует переменную ex типа Application.Exception
    ' Поместим End Try после шага 12.

    ' 6. Присвоим переменной ContextMenuExtension, объявленной на шаге 2 значение
    ' New ContextMenuExtension


    ' 7. Установим свойство Title объекта ContextMenuExtension, созданного на прошлом шаге
    ' равным "Circle Jig" (будет запускаться команда, завершенную в Lab7).


    ' 8. Объявим переменную класса MenuItem с именем mi. Создадим её равной
    ' New MenuItem. В качестве строкового параметра используем строку
    ' "Run Circle Jig".


    ' 9. Контекстное меню работает следующим образом: каждому пункту меню мы
    ' ставим в соответствие функцию-член, которая будет обрабатывать событие
    ' выбора пункта меню.
    ' Используем ключевое слово VB AddHandler и AddressOf чтобы указать, что мы
    ' хотим определить событие, которое будет обработано одной из функций
    ' В качестве параметра object используем событие Click объекта MenuItem,
    ' созданного на шаге 8. В качестве параметра delegate используем функцию с
    ' именем CallbackOnClick, которую мы создадим на шаге 20.


    ' 10. Используем метод Add коллекции MenuItems объекта ContextMenuExtension,
    ' созданного на шаге 6. В качестве параметра передаём MenuItem, созданный на шаге 8.


    ' 11. Используем метод AddDefaultContextMenuExtension объекта Application.
    ' В качестве параметра передаём объект ContextMenuExtension


    ' 12. Используем переменную типа Editor, созданную на шаге 4 и печатаем сообщение
    ' в командной строке:
    ' "Error Adding Context Menu: " + ex.Message


    ' 13. Создадим процедуру с именем RemoveContextMenu.
    ' Замечание: Поместим End Sub после шага 19.


    ' 14. Объявим переменную класса Editor. Создаём её путём присвоения ей
    ' значения равного свойству Editor объекта MdiActiveDocument

    ' 15. Добавим блок Try/Catch/Finally.
    ' Заметка: поместим Catch после шага 18. Пусть catch использует переменную
    ' типа Application.Exception с именем ex
    ' Поместим End Try после шага 19.

    ' 16. Используем оператор "If Then" для проверки равна ли
    ' ContextMenuExtension, объявленная на шаге step 2, Nothing (Not Is  Nothing).
    ' Заметка: поместим "End If" после шага 18


    ' 17. В операторе If, используем метод RemoveDefaultContextMenuExtension
    ' объекта Application. Передаем в качестве параметра ContextMenuExtension, объявленная на шаге 2

    ' 18. Присвоим ContextMenuExtension, объявленному на шаге 2, значение Nothing

    ' 19. Используем editor и напечатаем сообщение:
    ' "Error Removing Context Menu: " + ex.Message


    ' 20. Создадим процедуру с именем CallbackOnClick. Этот метод будет вызваться,
    ' когда выбран пункт меню. Установка была на шаге 9.
    ' Заметка: Поместим End Sub после шага 22.


    ' 21. Используем оператор Using и создадим переменную типа DocumentLock.
    ' Присвоим ей значение возвращаемое методом.MdiActiveDocument.LockDocument
    ' (Т.к. это событие выполняется вне контекста документа, нам приходится
    ' блокировать документ). Так реализовано в AutoCAD, что данные хранящиеся в его документах
    ' могут модифицировать команды, которые выполняются в контексте этих документов.
    ' Когда мы выполняем наш код как реакцию на контекстное меню, мы получаем доступ
    ' к документу из вне контекста документа.
    ' Чтобы разблокировать документ достаточно просто удалить (метод Dispose) объект DocumentLock,
    ' который вернул запрос на блокировку документа.
    ' Заметка: поместим оператор End Using после шага 22.


    ' 22. Вызовем функцию CircleJig().



    ' 23. Внутри процедуры Initialize. (созданной на шаге 1) добавим
    ' вызов AddContextMenu(). Это добавит контекстное меню при загрузке этой.NET dll
    ' Заметка: Переходим к шагу 24


    ' 37. Внутри процедуры Initialize. Раскомментарим эту строку после того, как мы проделали шаги 24 - 27

    ' Это выполнится при загрузке dll в AutoCAD
    ' AddTabDialog()


    ' 24. Внутри процедуры Terminate. (созданной Visual Studio на шаге 1) добавим вызов
    ' RemoveContextMenu(). Это удалит контекстное меню при выгрузке.NET dll
    ' Перед продолжением на шаге 25, скомпилируем проект и загрузим .NET dll в AutoCAD.
    ' Правый клик на области чертежа. Вы должны увидеть новый пункт меню: "Circle Jig"


    ' 25. Раскомментируйте это для того, чтобы командная строка, после запуска команды из меню
    ' пришла в нормальное состояние
    ' Imports System.Runtime.InteropServices '(Перенесите за пределы класса. Нужна для P/Invoke)
    'acedPostCommand("CANCELCMD") ' Перенесите это после CircleJig() на шаге 22
    '<DllImport("acad.exe", CharSet:=CharSet.Unicode, EntryPoint:="?acedPostCommand@@YAHPB_W@Z")> _
    'Public Shared Function acedPostCommand(ByVal cmd As String) As Boolean
    'End Function

    ' P.S.: У меня есть сомнения в том, что для восстановления командной строки
    ' нужно вызывать эту функцию, а не acedPostCommandPrompt.
    ' Поэтому вставим и её описание:
    '<DllImport("acad.exe", EntryPoint:="acedPostCommandPrompt")> _
    'Public Shared Sub acedPostCommandPrompt()
    'End Sub
    'acedPostCommandPrompt() ' Перенесите это после CircleJig() на шаге 22




    ' Lab8 Шаги 26 - 37. Добавляем вкладку к диалогу Настройки.
    ' Чтобы добавить вкладку нужно подписаться на сообщение (событие), что диалог Настройки запущен
    ' Это осуществляется путем передачи адреса функции-члена.
    ' Необходимо будет обеспечить функциональность обратного вызова; Второй аргумент
    ' передаваемый в функцию обратного вызова -  объект класса
    ' TabbedDialogEventArgs, который должен использоваться для вызова его метода
    ' AddTab. AddTab получает строку заголовка и экземпляр класса TabbedDialogExtension,
    ' который является оберткой для нашей формы. Внутрь конструктора
    ' класса TabbedDialogExtension мы передаем новый экземпляр нашей формы адрес  функцию обратного вызова
    ' в которой мы обрабатываем события OnOK, OnCancel и OnHelp.

    ' 26. Сначала объявим разделяемую (Shared) строковую переменную. Эта переменная устанавливается
    ' из нашей вкладки в диалоге Настройки. Назовём её myVariable

    ' 27. Добавим Public Shared процедуру с именем AddTabDialog. Мы вызовем её из метода
    ' Initialize(), созданного на шаге 1
    ' Заметка: Поместим End Sub после шага 28.

    ' 28. Воспользуемся оператором AddHandler для обработки события DisplayingOptionDialog
    ' класса Application. В качестве первого параметра - событие DisplayingOptionDialog класса Application
    ' Для второго параметра (Delegate) используем оператор
    ' AddressOf и имя процедуры, которую мы создадим на шаге 29
    ' (её имя TabHandler)


    ' 29. Создаём Private Shared Sub с именем TabHandler. Эта процедура, которая
    ' будет вызваться, когда диалог Настройка появляется на экране. (Имя должно
    ' совпадать с именем параметра делегата из шага 28. Первый параметр - объект
    ' (Используем ByVal и имя sender).
    ' Второй параметр типа TabbedDialogEventArgs.
    ' (Используем ByVal, имя e, тип Autodesk.AutoCAD.ApplicationServices.TabbedDialogEventArgs)
    ' Заметка: Поместим End Sub после шага 33


    ' 30. Объявим переменную как пользовательский контрол, который мы собираемся
    ' добавить к диалогу Настройки. Назовём её myCustomTab. Используем оператор New для создания.

    ' 31. Объявим переменную типа TabbedDialogAction. Создадим её оператором New
    ' для создания нового обработчика TabbedDialogAction и передаём адрес метода
    ' OnOk пользовательского контрола из шага 29.
    ' Заметка: Метод OnOk будет добавлен на шагах 35 - 36. (Вы можете сразу
    ' перейти к этим шагам в коде формы myCustomTab, ну а потом вернутся обратно)

    ' 32. Объявим переменную типа TabbedDialogExtension. Создадим её оператором New,
    ' чтобы создать новый TabbedDialogExtension с параметром control
    ' соответствующим пользовательскому контролу из шага 30
    ' и переменной типа TabbedDialogAction из шага 31.

    ' 33. Используем метод AddTab аргумента TabbedDialogEventArgs переданного в событие.
    ' (с именем e). В качестве параметра Name используем "Value for custom variable". В качестве параметра
    ' TabbedDialogExtension используем TabbedDialogExtension из шага 32.
    ' Заметка: Перейдем к шагу 34 в функции TestTab.


    ' Запустите эту команду для получения значения, установлено в форме
    <CommandMethod("testTab")> _
    Public Sub TestTab()
        Dim ed As Editor = Application.DocumentManager.MdiActiveDocument.Editor

        ' 34. Раскомментируйте эту строку для печати сообщения из вкладки,
        ' добавленной на предыдущих шагах, в командную строку
        ' Заметка: Возможно придется изменить имя переменной myVariable на имя,
        ' которое вы использовали на шаге 26
        ' Приступим к шагам 35 - 36 в окне с кодом для UserControl. (имя myCustomTab)
        ' если вы это еще не сделали. Также выполните шаг 37 и вернитесь к шагу 23
        ' ed.WriteMessage(myVariable.ToString())


        ' После шагов 35-36 выполните в VS Build, загрузите dll в AutoCAD и запустите команду _OPTIONS
        ' чтобы увидеть пользовательский диалог. Установите значение текстовой
        ' строки, нажмите Ok и запустите эту команду, чтобы увидеть значение,
        ' установленное в диалоге, в командной строке
        ' После этого можно перейти к шагам 38-46 в окне с кодом для
        ' UserControl1. (Добавим обработку для Drag & Drop).

    End Sub




    ' Определяем команду 'helloworld'
    <CommandMethod("helloworld")> _
    Public Sub helloworld()

        ' Получаем объект редактора
        Dim ed As Autodesk.AutoCAD.EditorInput.Editor = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Editor
        ' Пишем в командной строке
        ed.WriteMessage(vbCr + "Здравствуй, Мир!")

    End Sub

    <CommandMethod("addAnEnt")> _
    Public Sub AddAnEnt()

        ' Получаем объект редактора т.к. собираемся кое-что вводить
        Dim ed As Editor = Application.DocumentManager.MdiActiveDocument.Editor

        ' уточним какой тип примитива будем создавать
        Dim getWhichEntityOptions As PromptKeywordOptions = New PromptKeywordOptions("Which entity do you want to create? [Circle/Block] : ", "Circle Block")
        ' теперь запросим его
        Dim getWhichEntityResult As PromptResult = ed.GetKeywords(getWhichEntityOptions)
        ' Если OK
        If (getWhichEntityResult.Status = PromptStatus.OK) Then

            ' Проверим какой тип примитива требуется создать
            Select Case getWhichEntityResult.StringResult

                Case "Circle"

                    ' Укажем центр окружности
                    Dim getPointOptions As PromptPointOptions = New PromptPointOptions("Pick Center Point : ")
                    Dim getPointResult As PromptPointResult = ed.GetPoint(getPointOptions)
                    ' Если OK
                    If (getPointResult.Status = PromptStatus.OK) Then

                        ' получаем радиус
                        Dim getRadiusOptions As PromptDistanceOptions = New PromptDistanceOptions("Pick Radius : ")
                        ' в качестве базовой точки - точку которую мы указали для центра
                        getRadiusOptions.BasePoint = getPointResult.Value
                        ' сообщим механизму ввода использовать базовую точку
                        getRadiusOptions.UseBasePoint = True
                        ' теперь получим радиус
                        Dim getRadiusResult As PromptDoubleResult = ed.GetDistance(getRadiusOptions)
                        ' Если всё OK
                        If (getRadiusResult.Status = PromptStatus.OK) Then

                            ' Нужно добавить окружность к текущему пространству
                            ' Получаем активную базу
                            Dim dwg As Database = ed.Document.Database
                            ' стартуем транзакцию
                            Dim trans As Transaction = dwg.TransactionManager.StartTransaction()
                            Try

                                ' создаём новую окружность
                                Dim circle As New Circle(getPointResult.Value, Vector3d.ZAxis, getRadiusResult.Value)
                                ' открываем активное пространство (запись таблицы блоков) для записи
                                Dim btr As BlockTableRecord = trans.GetObject(dwg.CurrentSpaceId, OpenMode.ForWrite)
                                ' добавляем окружность к текущему пространству (скорее всего пространство модели)
                                btr.AppendEntity(circle)
                                ' сообщим транзакции о необходимости автозакрыть объект окружности
                                trans.AddNewlyCreatedDBObject(circle, True)
                                ' завершаем (commit) транзакцию
                                trans.Commit()

                            Catch ex As Exception
                                ' Есть исключение - сообщим о нём
                                ed.WriteMessage("problem due to " + ex.Message)
                            Finally
                                ' Дело сделано, в любом случае освободим транзакцию
                                trans.Dispose()
                            End Try

                        End If
                    End If

                Case "Block"

                    ' вводим имя блока
                    Dim blockNameOptions As PromptStringOptions = New PromptStringOptions("Enter name of the Block to create : ")
                    ' запрещаем пробелы в имени блока
                    blockNameOptions.AllowSpaces = False
                    ' получаем имя
                    Dim blockNameResult As PromptResult = ed.GetString(blockNameOptions)
                    ' Если ok
                    If (blockNameResult.Status = PromptStatus.OK) Then

                        ' Создадим определение блока
                        ' получаем активный чертеж
                        Dim dwg As Database = ed.Document.Database
                        ' начнем транзакцию
                        Dim trans As Transaction = dwg.TransactionManager.StartTransaction
                        Try

                            ' создаем новое определение блока
                            Dim newBlockDef As BlockTableRecord = New BlockTableRecord
                            ' задаём имя блоку
                            newBlockDef.Name = blockNameResult.StringResult

                            ' добавим определение блока в таблицу блоков
                            ' откроем таблицу блоков для чтения и проверим есть ли уже такое имя блока в ней
                            Dim blockTable As BlockTable = trans.GetObject(dwg.BlockTableId, OpenMode.ForRead)
                            ' проверяем есть ли уже такое имя
                            If (blockTable.Has(blockNameResult.StringResult) = False) Then
                                ' Если нет, то можем добавить его
                                ' только сначала нужно переключится в режим для записи
                                blockTable.UpgradeOpen()
                                blockTable.Add(newBlockDef)
                                ' сообщаем менеджеру транзакций о новом объекте для автозакрытия
                                trans.AddNewlyCreatedDBObject(newBlockDef, True)
                            End If

                            ' теперь добавим несколько объектов к определению блока
                            Dim circle1 As New Circle(New Point3d(0, 0, 0), Vector3d.ZAxis, 10)
                            Dim circle2 As New Circle(New Point3d(20, 10, 0), Vector3d.ZAxis, 10)
                            Dim circle3 As New Circle(New Point3d(40, 20, 0), Vector3d.ZAxis, 10)
                            Dim circle4 As New Circle(New Point3d(60, 30, 0), Vector3d.ZAxis, 10)
                            Dim circle5 As New Circle(New Point3d(80, 40, 0), Vector3d.ZAxis, 10)
                            newBlockDef.AppendEntity(circle1)
                            newBlockDef.AppendEntity(circle2)
                            newBlockDef.AppendEntity(circle3)
                            newBlockDef.AppendEntity(circle4)
                            newBlockDef.AppendEntity(circle5)
                            ' сообщим менеджеру транзакций о новых объектах
                            trans.AddNewlyCreatedDBObject(circle1, True)
                            trans.AddNewlyCreatedDBObject(circle2, True)
                            trans.AddNewlyCreatedDBObject(circle3, True)
                            trans.AddNewlyCreatedDBObject(circle4, True)
                            trans.AddNewlyCreatedDBObject(circle5, True)

                            ' теперь вставим блок в текущее пространство - запросим точку вставки
                            Dim blockRefPointOptions As PromptPointOptions = New PromptPointOptions("Pick insertion point of Block : ")
                            Dim blockRefPointResult As PromptPointResult = ed.GetPoint(blockRefPointOptions)
                            ' если не всё в порядке
                            If (blockRefPointResult.Status <> PromptStatus.OK) Then
                                ' освобождаем транзакцию, чтобы отменить изменения и выходим
                                trans.Dispose()
                                Return
                            End If
                            ' теперь у нас есть определение блока и точка для вставки - создадим вставку блока
                            Dim blockRef As BlockReference = New BlockReference(blockRefPointResult.Value, newBlockDef.ObjectId)
                            ' открываем текущее пространство для записи и добавим вставку блока в него
                            Dim curSpace As BlockTableRecord = trans.GetObject(dwg.CurrentSpaceId, OpenMode.ForWrite)
                            ' добавляем вставку блока
                            curSpace.AppendEntity(blockRef)
                            ' укажем транзакции о новом объекте для автозакрытия
                            trans.AddNewlyCreatedDBObject(blockRef, True)

                            ' Если всё в норме - завершим транзакцию
                            trans.Commit()

                        Catch ex As Exception
                            ' Есть проблема - сообщим о ней
                            ed.WriteMessage("a problem occured because " + ex.Message)
                        Finally
                            ' чтобы не произошло, а транзакцию нужно освободить
                            trans.Dispose()

                        End Try

                    End If

            End Select
        End If

    End Sub

    ' Объявим объект PaletteSset - он должен быть создан только один раз
    Public myPaletteSet As Autodesk.AutoCAD.Windows.PaletteSet
    ' Нам нужна палитра, которая размещается на PaletteSet
    Public myPalette As UserControl1

    ' команда palette
    <CommandMethod("palette")> _
    Public Sub palette()

        ' проверим создана ли уже
        If (myPaletteSet = Nothing) Then
            ' создаём PaletteSet с уникальным GUID
            myPaletteSet = New Autodesk.AutoCAD.Windows.PaletteSet("My Palette", New Guid("D61D0875-A507-4b73-8B5F-9266BEACD596"))
            ' создаём новую палитру, внутри которой контрол дерево (Tree Control)
            myPalette = New UserControl1
            ' теперь добавим palette к paletteset
            myPaletteSet.Add("Palette1", myPalette)

        End If

        ' сделаем видимым paletteset
        myPaletteSet.Visible = True

    End Sub

    <CommandMethod("addDBEvents")> _
    Public Sub addDBEvents()

        ' нужно предварительно создать палитру
        If myPalette Is Nothing Then
            ' получаем объект редактора
            Dim ed As Autodesk.AutoCAD.EditorInput.Editor = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Editor
            ' пишем в командной строке
            ed.WriteMessage(vbCr + "Please call the 'palette' command first")
            Exit Sub
        End If

        ' получаем активную базу
        Dim curDwg As Database = Application.DocumentManager.MdiActiveDocument.Database
        ' добавим обработчики событий
        AddHandler curDwg.ObjectAppended, New ObjectEventHandler(AddressOf callback_ObjectAppended)
        AddHandler curDwg.ObjectErased, New ObjectErasedEventHandler(AddressOf callback_ObjectErased)
        AddHandler curDwg.ObjectReappended, New ObjectEventHandler(AddressOf callback_ObjectReappended)
        AddHandler curDwg.ObjectUnappended, New ObjectEventHandler(AddressOf callback_ObjectUnappended)

    End Sub

    Private Sub callback_ObjectAppended(ByVal sender As Object, ByVal e As ObjectEventArgs)

        ' добавим имя класса объекта к tree view
        Dim newNode As System.Windows.Forms.TreeNode = myPalette.TreeView1.Nodes.Add(e.DBObject.GetType().ToString())
        ' записываем ID объекта для того, чтобы его можно было потом найти
        newNode.Tag = e.DBObject.ObjectId.ToString()

    End Sub

    Private Sub callback_ObjectErased(ByVal sender As Object, ByVal e As ObjectErasedEventArgs)

        ' Если объект удалён
        If e.Erased Then
            ' находим объект в контроле treeview чтобы удалить его
            For Each node As Forms.TreeNode In myPalette.TreeView1.Nodes
                ' если это он
                If (node.Tag = e.DBObject.ObjectId.ToString) Then
                    node.Remove()
                    Exit For
                End If
            Next
            ' если объект восстановлен
        Else
            ' добавим имя класса объекта к tree view
            Dim newNode As System.Windows.Forms.TreeNode = myPalette.TreeView1.Nodes.Add(e.DBObject.GetType().ToString())
            ' записываем ID объекта для того, чтобы его можно было потом найти
            newNode.Tag = e.DBObject.ObjectId.ToString()
        End If
    End Sub
    Private Sub callback_ObjectReappended(ByVal sender As Object, ByVal e As ObjectEventArgs)

        ' добавим имя класса объекта к tree view
        Dim newNode As Forms.TreeNode = myPalette.TreeView1.Nodes.Add(e.DBObject.GetType().ToString())
        ' записываем ID объекта для того, чтобы его можно было потом найти
        newNode.Tag = e.DBObject.ObjectId.ToString()

    End Sub

    Private Sub callback_ObjectUnappended(ByVal sender As Object, ByVal e As ObjectEventArgs)

        ' находим объект в контроле treeview чтобы удалить его
        For Each node As Forms.TreeNode In myPalette.TreeView1.Nodes
            ' если это он
            If (node.Tag = e.DBObject.ObjectId.ToString) Then
                node.Remove()
                Exit For
            End If
        Next

    End Sub

    <CommandMethod("addData")> _
    Public Sub addData()

        ' получаем объект редактора
        Dim ed As Editor = Application.DocumentManager.MdiActiveDocument.Editor
        ' указываем объект для добавления данных!
        Dim getEntityResult As PromptEntityResult = ed.GetEntity("Pick an entity to add an Extension Dictionary to : ")
        ' Если всё ok
        If (getEntityResult.Status = PromptStatus.OK) Then
            ' стартуем транзакцию
            Dim trans As Transaction = ed.Document.Database.TransactionManager.StartTransaction
            Try

                ' открываем объект для чтения
                Dim ent As Entity = trans.GetObject(getEntityResult.ObjectId, OpenMode.ForRead)
                ' проверяем нет ли ещё ExtensionDictionary у этого примитива
                If (ent.ExtensionDictionary.IsNull) Then
                    ' Чтобы создать переходим в режим для записи
                    ent.UpgradeOpen()
                    ' создаём
                    ent.CreateExtensionDictionary()
                End If
                ' Теперь всё должно быть нормально
                ' Открываем для чтения
                Dim extensionDict As DBDictionary = trans.GetObject(ent.ExtensionDictionary, OpenMode.ForRead)

                Try
                    ' Проверяем есть у же наша запись - если нет, то возникнет исключение,
                    ' которое обработаем в Catch
                    Dim entryId As ObjectId = extensionDict.GetAt("MyData")

                    ' Если мы здесь, то всё OK
                    ' печатаем данные
                    ed.WriteMessage(ControlChars.Lf + "This entity already has data...")
                    ' извлекаем Xrecord
                    Dim myXrecord As Xrecord
                    ' читаем её из ExtensionDictionary
                    myXrecord = trans.GetObject(entryId, OpenMode.ForRead)
                    ' печатаем все её значения
                    For Each value As TypedValue In myXrecord.Data
                        ed.WriteMessage(ControlChars.Lf + value.TypeCode.ToString() + " . " + value.Value.ToString())
                    Next

                Catch
                    ' переходим в режим для записи
                    extensionDict.UpgradeOpen()

                    ' создаём новую Xrecord
                    Dim myXrecord As New Xrecord
                    ' создаём список буферов
                    Dim data As ResultBuffer = New ResultBuffer(New TypedValue(DxfCode.Int16, 1), _
                                                                New TypedValue(DxfCode.Text, "MyStockData"), _
                                                                New TypedValue(DxfCode.Real, 51.899999999999999), _
                                                                New TypedValue(DxfCode.Real, 100.0), _
                                                                New TypedValue(DxfCode.Real, 320.60000000000002))
                    ' добавляем его к Xrecord
                    myXrecord.Data = data

                    ' создаём запись
                    extensionDict.SetAt("MyData", myXrecord)
                    ' сообщаем транзакции о новом объекте Xrecord (для автозакрытия)
                    trans.AddNewlyCreatedDBObject(myXrecord, True)

                    ' теперь сообщим нашему TreeView контролу о новых данных
                    ' находим Tag, который нам нужен в TreeView
                    ' Неплохо бы проверить, что палитра уже создана - в противном случае будет аварийное завершение
                    If Not myPalette Is Nothing Then
                        For Each node As Forms.TreeNode In Me.myPalette.TreeView1.Nodes
                            ' Если это нужная нам запись
                            If (node.Tag = ent.ObjectId.ToString()) Then
                                ' добавим новую запись к записи (поддерево)
                                Dim childNode As Forms.TreeNode = node.Nodes.Add("Extension Dictionary")
                                ' теперь добавим данные
                                For Each value As TypedValue In myXrecord.Data
                                    childNode.Nodes.Add(value.ToString())
                                Next

                                ' Всё сделано - выходим из цикла
                                Exit For
                            End If
                        Next
                    End If
                End Try

                ' Всё сделано - завершаем транзакцию
                trans.Commit()

            Catch ex As Exception
                ' есть проблема - сообщим о ней
                ed.WriteMessage("a problem occured because " + ex.Message)
            Finally
                ' чтобы не случилось, а транзакцию нужно освободить
                trans.Dispose()

            End Try

        End If

    End Sub

    <CommandMethod("addDataToNOD")> _
    Public Sub addDataToNOD()

        ' получаем объект редактора
        Dim ed As Editor = Application.DocumentManager.MdiActiveDocument.Editor
        ' стартуем транзакцию
        Dim trans As Transaction = ed.Document.Database.TransactionManager.StartTransaction
        Try

            ' Открываем словарь именованных объектов (NOD) для чтения
            Dim nod As DBDictionary = trans.GetObject(ed.Document.Database.NamedObjectsDictionaryId, OpenMode.ForRead)

            Try
                ' проверяем есть ли наша запись уже в NOD - если нет, то возникнет исключение
                ' которое мы обработаем в Catch
                Dim entryId As ObjectId = nod.GetAt("MyData")

                ' Если мы здесь, то всё OK
                ' печатаем данные
                ed.WriteMessage(ControlChars.Lf + "This entity already has data...")
                ' извлекаем Xrecord
                Dim myXrecord As Xrecord
                ' читаем её из словаря NOD
                myXrecord = trans.GetObject(entryId, OpenMode.ForRead)
                ' печатаем все её значения
                For Each value As TypedValue In myXrecord.Data
                    ed.WriteMessage(ControlChars.Lf + value.TypeCode.ToString() + " . " + value.Value.ToString())
                Next

            Catch
                ' переключаемся в режим для записи
                nod.UpgradeOpen()

                ' создаём XRecord
                Dim myXrecord As New Xrecord
                ' создаём список буферов
                Dim data As ResultBuffer = New ResultBuffer(New TypedValue(DxfCode.Int16, 1), _
                                                            New TypedValue(DxfCode.Text, "MyCompanyDefaultSettings"), _
                                                            New TypedValue(DxfCode.Real, 51.899999999999999), _
                                                            New TypedValue(DxfCode.Real, 100.0), _
                                                            New TypedValue(DxfCode.Real, 320.60000000000002))
                ' добавляем его к Xrecord
                myXrecord.Data = data

                ' создаём запись
                nod.SetAt("MyData", myXrecord)
                ' сообщаем транзакции о новом объекте (для автозакрытия)
                trans.AddNewlyCreatedDBObject(myXrecord, True)

            End Try

            ' Всё OK, закрываем транзакцию
            trans.Commit()

        Catch ex As Exception
            ' есть проблема - сообщим о ней
            ed.WriteMessage("a problem occurred because " + ex.Message)
        Finally
            ' чтобы не случилось, а транзакцию нужно освободить
            trans.Dispose()

        End Try

    End Sub

    <CommandMethod("addpointmonitor")> _
    Public Sub startMonitor()

        ' получаем объект редактора
        Dim ed As Editor = Application.DocumentManager.MdiActiveDocument.Editor
        ' подписываемся на событие редактора PointMonitor
        AddHandler ed.PointMonitor, New PointMonitorEventHandler(AddressOf MyPointMonitor)

    End Sub

    Public Sub MyPointMonitor(ByVal sender As Object, ByVal e As PointMonitorEventArgs)

        If e.Context Is Nothing Then
            Return
        End If

        ' сначала проверим что у нас под курсором
        Dim fullEntPath() As FullSubentityPath = e.Context.GetPickedEntities()
        If (fullEntPath.Length) Then
            ' сначала покажем всплывающую подсказку (ToolTip)
            ' стартуем транзакцию
            Dim trans As Transaction = Application.DocumentManager.MdiActiveDocument.Database.TransactionManager.StartTransaction
            Try

                ' открываем примитив для чтения
                Dim ent As Entity = trans.GetObject(fullEntPath(0).GetObjectIds(0), OpenMode.ForRead)
                e.AppendToolTipText("The Entity is a " + ent.GetType().ToString())

                ' убедимся, что палитра создана
                If (myPalette Is Nothing) Then
                    Return
                End If


                ' если мы здесь, то палитра есть - подсветим в ней наш примитив
                ' находи его по Tag в дереве (TreeView)
                Dim fontRegular As System.Drawing.Font = New System.Drawing.Font("Microsoft Sans Serif", 8, Drawing.FontStyle.Regular)
                Dim fontBold As System.Drawing.Font = New System.Drawing.Font("Microsoft Sans Serif", 8, Drawing.FontStyle.Bold)

                ' приостановим обновление TreeView контрол до момента, пока мы его не модифицируем
                Me.myPalette.TreeView1.SuspendLayout()

                For Each node As Forms.TreeNode In Me.myPalette.TreeView1.Nodes
                    ' если это наш примитив
                    If (node.Tag = ent.ObjectId.ToString()) Then
                        If Not fontBold.Equals(node.NodeFont) Then
                            node.NodeFont = fontBold
                            '
                            node.Text = node.Text
                        End If
                    Else
                        If Not fontRegular.Equals(node.NodeFont) Then
                            node.NodeFont = fontRegular
                        End If
                    End If
                Next

                ' теперь можно разрешить обновление TreeView
                Me.myPalette.TreeView1.ResumeLayout()
                Me.myPalette.TreeView1.Refresh()
                Me.myPalette.TreeView1.Update()

                ' Всё хорошо - завершаем транзакцию
                trans.Commit()
            Catch ex As Exception

            Finally
                ' что бы не случилось - освобождаем транзакцию
                trans.Dispose()

            End Try

        End If

        ' Сделаем что-нибудь бессмысленое :-)!
        'If (e.Context.History And PointHistoryBits.NotDigitizer) Then
        '    ' это значит, что мышкой кликнули, так что
        '    ' создадим окружность
        '    Dim circle As Circle = New Circle(e.Context.RawPoint, Vector3d.ZAxis, 10)
        '    ' рисуем её
        '    e.Context.DrawContext.Geometry.Draw(circle)
        '    ' подождем немного
        '    System.Threading.Thread.Sleep(50)
        '    ' меняем радиус - снова рисуем
        '    circle.Radius = 20
        '    e.Context.DrawContext.Geometry.Draw(circle)
        '    ' подождём немного
        '    System.Threading.Thread.Sleep(50)
        '    ' меняем радиус - снова рисуем
        '    circle.Radius = 40
        '    e.Context.DrawContext.Geometry.Draw(circle)
        '    ' подождём немного
        '    System.Threading.Thread.Sleep(50)
        '    ' меняем радиус - снова рисуем
        '    circle.Radius = 80
        '    e.Context.DrawContext.Geometry.Draw(circle)
        '    ' подождём немного
        '    System.Threading.Thread.Sleep(50)

        'End If

    End Sub

    <CommandMethod("newInput")> _
    Public Sub NewInput()

        ' стартуем наш InputPointMonitor
        ' получаем объект редактора
        Dim ed As Editor = Application.DocumentManager.MdiActiveDocument.Editor
        ' подписываемся на событие PointMonitor
        AddHandler ed.PointMonitor, New PointMonitorEventHandler(AddressOf MyInputMonitor)
        ed.TurnForcedPickOn()

        ' теперь укажем какую-нибудь точкук, это эмулирует реальный ввод
        ' укажем центр окружности
        Dim getPointOptions As PromptPointOptions = New PromptPointOptions("Pick A Point : ")
        Dim getPointResult As PromptPointResult = ed.GetPoint(getPointOptions)
        ' Если ok
        If (getPointResult.Status = PromptStatus.OK) Then
            ' Что-то делаем
        End If

        ' теперь отпишемся от события, т.к. оно нас уже не интересует
        RemoveHandler ed.PointMonitor, AddressOf MyInputMonitor

    End Sub

    Public Sub MyInputMonitor(ByVal sender As Object, ByVal e As PointMonitorEventArgs)

        If e.Context Is Nothing Then
            Return
        End If

        ' проверим что под курсором
        Dim fullEntPath() As FullSubentityPath = e.Context.GetPickedEntities()
        If (fullEntPath.Length) Then

            ' стартуем транзакцию
            Dim trans As Transaction = Application.DocumentManager.MdiActiveDocument.Database.TransactionManager.StartTransaction
            Try

                ' открываем примитив для чтения, он должен быть наследником Curve
                Dim ent As Curve = trans.GetObject(fullEntPath(0).GetObjectIds(0), OpenMode.ForRead)

                ' проверяем есть ли у него ExtensionDictionary
                If (ent.ExtensionDictionary.IsValid) Then

                    ' если да - открываем для чтения
                    Dim extensionDict As DBDictionary = trans.GetObject(ent.ExtensionDictionary, OpenMode.ForRead)

                    ' находим запись
                    Dim entryId As ObjectId = extensionDict.GetAt("MyData")

                    ' Если мы здесь - всё ОК
                    ' извлекаем Xrecord
                    Dim myXrecord As Xrecord
                    ' читаем её из ExtensionDictionary
                    myXrecord = trans.GetObject(entryId, OpenMode.ForRead)
                    ' рисуем now draw the positions
                    For Each value As TypedValue In myXrecord.Data
                        ' Если TypeCode - плавающее число, будем считать что это расстояние
                        If (value.TypeCode = DxfCode.Real) Then
                            ' рисуем временную графику вдоль кривойd на заданных расстояниях

                            ' получаем точку на кривой на этом расстоянии
                            Dim pnt As Point3d = ent.GetPointAtDist(value.Value)

                            ' определим сколько пикселей в единичном квадратеe - так как мы хотим установить размер временной графики
                            Dim pixels As Point2d = e.Context.DrawContext.Viewport.GetNumPixelsInUnitSquare(pnt)
                            ' установим постоянные расстояния
                            Dim xDist As Double = 10 / pixels.X
                            Dim yDist As Double = 10 / pixels.Y

                            ' рисуем временную графику - окружность
                            Dim circle As Circle = New Circle(pnt, Vector3d.ZAxis, xDist)
                            e.Context.DrawContext.Geometry.Draw(circle)

                            ' еще временная графика - текст
                            Dim text As DBText = New DBText
                            ' всегда неплохо устанавливать примитиву значения по умолчанию для чертежа (особенно для текстов, размеров и т.д.)
                            text.SetDatabaseDefaults()
                            ' установим точку вставки текста как у центра окружности, но смещенную на радиус
                            text.Position = pnt + New Vector3d(xDist, yDist, 0)
                            text.TextString = value.Value.ToString()
                            text.Height = yDist
                            e.Context.DrawContext.Geometry.Draw(text)
                        End If
                    Next
                End If

                ' всё нормально - завершим транзакцию
                trans.Commit()
            Catch ex As Exception

            Finally
                ' чтобы не случилось - освободим транзакцию
                trans.Dispose()

            End Try

        End If

    End Sub


    ' Класс EntityJig позволяет "jig" одновременно один примитив.
    Class MyCircleJig
        Inherits EntityJig

        ' Нужно два ввода для окружности - центр и радиус.
        Private centerPoint As Point3d
        Private radius As Double

        ' Т.к. требуется два ввода (точка центра и радиус), то нужно помнить номер ввода
        ' (используется чтобы знать что вводить).
        Private currentInputValue As Integer

        '  Мы используем свойство для чтения/записи целого значения
        Property CurrentInput() As Integer
            Get
                Return currentInputValue
            End Get
            Set(ByVal value As Integer)
                currentInputValue = value
            End Set


        End Property

        ' Создаём конструктор по умолчанию.
        Sub New(ByVal ent As Entity)

            ' Вызываем MyBase.New() и ent, переданный в конструктор. Это необходимо
            ' сделать, так как в базовом классе "EntityJig" нет доступного конструктора
            ' Sub New, которорый можно вызвать без аргументов
            MyBase.New(ent)

        End Sub


        Protected Overrides Function Sampler(ByVal prompts As Autodesk.AutoCAD.EditorInput.JigPrompts) As Autodesk.AutoCAD.EditorInput.SamplerStatus

            ' В case используем член класса currentInputValue,
            Select Case (currentInputValue)

                ' Используем 0 (нуль) для case. (получаем центр окружности)
                Case 0

                    ' Это должно использоваться для проверки того, что курсор сдвинулся в jig.
                    ' Если даже пользователь ничего не изменит, Autocad непрерывно будет вызывать функцию sampler,
                    ' и функцию update, и вы увидите эффект мерцания на экране.
                    Dim oldPnt As Point3d = centerPoint

                    Dim jigPromptResult As PromptPointResult = prompts.AcquirePoint("Pick center point : ")

                    ' Проверим статус the PromptPointResult
                    If (jigPromptResult.Status = PromptStatus.OK) Then

                        ' Делаем переменную член класса равным значению Value
                        ' свойства PromptPointResult
                        centerPoint = jigPromptResult.Value

                        ' Проверим сдвинулся ли курсор
                        If (oldPnt.DistanceTo(centerPoint) < 0.001) Then
                            ' Если мы здесь - значит курсор никуда не переместился
                            ' Возвращаем SamplerStatus.NoChange
                            Return SamplerStatus.NoChange
                        End If
                    End If

                    ' Курсор переместился - возвращаем SamplerStatus.OK
                    Return SamplerStatus.OK

                    ' Используем 1 для case. (получаем радиус окружности)
                Case 1

                    ' Проверим переместился ли курсор при вводе радиуса
                    Dim oldRadius As Double = radius

                    Dim jigPromptDistanceOpts As New JigPromptDistanceOptions("Pick radius : ")
                    jigPromptDistanceOpts.UseBasePoint = True

                    jigPromptDistanceOpts.BasePoint = centerPoint

                    ' Теперь мы готовы ввести радиус.
                    Dim jigPromptResult As PromptDoubleResult = prompts.AcquireDistance(jigPromptDistanceOpts)

                    ' Проверяем статус PromptDoubleResult
                    If (jigPromptResult.Status = PromptStatus.OK) Then

                        ' Присвоиваем переменной-члену radius равным свойству Value
                        ' объекта PromptDoubleResult
                        radius = jigPromptResult.Value

                        ' Проверяем не слишком ли мал радиус
                        If (System.Math.Abs(radius) < 0.1) Then
                            ' Произвольное значение предохраняет окружность,
                            ' чтобы она не стала слишком маленькой
                            radius = 1
                        End If

                        ' Проверим сдвинулся ли курсор.
                        If (System.Math.Abs(oldRadius - radius) < 0.001) Then
                            ' Если мы сюда попали, то курсор не сдвинулся
                            Return SamplerStatus.NoChange
                        End If
                    End If

                    Return SamplerStatus.OK

            End Select
        End Function


        Protected Overrides Function Update() As Boolean

            ' В этой функции (Update) при каждом вводе (перемещении курсора), мы должны обновить примитив
            Select Case (currentInputValue)
                ' Используем 0 (нуль) для case. (Обновляем центр окружности)
                Case 0

                    ' jig хранит окружность как объект типа Entity. Приведём его тип к Circle,
                    ' чтобы было проще получить доступ к его свойствам.
                    CType(Me.Entity, Circle).Center = centerPoint

                    ' Используем 1 для case. (Обновляем радиус окружности)
                Case 1

                    ' jig хранит окружность как объект типа Entity. Приведём его тип к Circle,
                    ' чтобы было проще получить доступ к его свойствам.
                    CType(Me.Entity, Circle).Radius = radius

            End Select

        End Function
    End Class


    ' Создаём команду для вызова EntityJig
    <CommandMethod("circleJig")> _
    Public Sub CircleJig()

        ' Создаём новый экземпляр окружности, который мы будем формировать в jig
        Dim circle As Circle = New Circle(Point3d.Origin, Vector3d.ZAxis, 10)

        ' Создаём jig.
        Dim jig As New MyCircleJig(circle)

        ' Теперь цикл ввода. 0 для позиции окружности и
        ' 1 для радиуса.
        For i As Integer = 0 To 1

            ' Устанавливаем режим ввода равным счетчику цикла.
            jig.CurrentInput = i

            ' Получаем объект редактора.
            Dim ed As Autodesk.AutoCAD.EditorInput.Editor = Application.DocumentManager.MdiActiveDocument.Editor

            ' Вызываем jig. Объявим переменную типа PromptResult и присвоим ей результат
            ' вызова метода Drag объекта Editor
            Dim promptResult As PromptResult = ed.Drag(jig)

            ' Убедимся, что свойство Status переменной PromptResult равно PromptStatus.OK.
            If (promptResult.Status = PromptStatus.Cancel Or promptResult.Status = PromptStatus.Error) Then
                ' Какие-то проблемы. Выходим
                Return
            End If

        Next

        ' jig закончен - как раз время добавить окружность в активную базу
        Dim dwg As Database = Application.DocumentManager.MdiActiveDocument.Database
        ' стартуем транзакцию
        Dim trans As Transaction = dwg.TransactionManager.StartTransaction
        Try
            ' открываем текущее пространство для записи
            Dim currentSpace As BlockTableRecord = trans.GetObject(dwg.CurrentSpaceId, OpenMode.ForWrite)
            ' добавим окружность в текущее пространство
            currentSpace.AppendEntity(circle)
            ' сообщим менеджеру транзакций о новом объекте (для автозакрытия)
            trans.AddNewlyCreatedDBObject(circle, True)

            ' Всё OK - завершаем транзакцию
            trans.Commit()

        Catch ex As Exception
        Finally
            ' чтобы не случилось, а транзакцию нужно освободить
            trans.Dispose()

        End Try

    End Sub
End Class
