﻿
// (C) Copyright 2002-2005 by Autodesk, Inc. 
// 
// Permission to use, copy, modify, and distribute this software in 
// object code form for any purpose and without fee is hereby granted, 
// provided that the above copyright notice appears in all copies and 
// that both that copyright notice and the limited warranty and 
// restricted rights notice below appear in all supporting 
// documentation. 
// 
// AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS. 
// AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF 
// MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE. AUTODESK, INC. 
// DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE 
// UNINTERRUPTED OR ERROR FREE. 
// 
// Use, duplication, or disclosure by the U.S. Government is subject to 
// restrictions set forth in FAR 52.227-19 (Commercial Computer 
// Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii) 
// (Rights in Technical Data and Computer Software), as applicable. 


using Autodesk.AutoCAD.Runtime;
using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.EditorInput;
using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.Geometry;

using Autodesk.AutoCAD.Windows;

using System.Runtime.InteropServices; //(Перенесли за пределы класса - нужно для P/Invoke) 



[assembly: ExtensionApplication(typeof(Lab8_Complete.adskClass))] 

namespace Lab8_Complete
{

    // Начало Lab8 
    // Чтобы иметь возможность выполнять инициализацию в момент загрузки, AutoCAD .NET приложение 
    // может реализовать специальный класс, позволяющий это. Этот класс должен реализовывать интерфейс 
    // IExtensionApplication, и объявлять атрибут уровня сборки, 
    // который показывает, что класс наследует ExtensionApplication. 
    // В этом случае класс может реагировать на события загрузки и выгрузки сборки в AutoCAD
    // В этой лабораторной мы добавим контекстное меню и вкладку в диалог команды _Options 
    // Мы так же сделаем доступным Drag & Drop для запуска команды AutoCAD при перетаскивании 
    // метки в чертеж AutoCAD. 

   
    public class adskClass : IExtensionApplication
    {

        // 1. Модифицируем класс asdkClass1 для реализации интерфейса IExtensionApplication. 
        // Добавим ": IExtensionApplication" к объявлению класса.
        // Заметка: Всего два метода интерфейса должны быть реализованы. 
        // Это Initialize() и Terminate(). Создайте эти функции с использованием 
        // ключевых слов public void.  
        // Скопируйте и вставьте функции с шагов 23 и 37 внутрь функции Initialize
        // и шаг 24 внутрь функции Terminate. 
        // Так же добавим этот атрибут (путём раскоментаривания следующей строки кода). 
        // (должно быть вне класса) 
        // Эта строка не обязательна, но увеличивает скорость загрузки 
        // [assembly: ExtensionApplication(typeof(Lab8.adskClass))]  

        // 2. Объявим переменную-член класса типа ContextMenuExtension. Она будет создана 
        // на шаге 6 

        ContextMenuExtension myContextMenu;

        // 3. Создаём функцию типа private void с именем AddContextMenu. 
        // Заметка: Поместим “}” после шага 12.
        private void AddContextMenu()
        {

            // 4. Объявим переменную типа Editor. Присвоим ей значение равное свойству 
            // Editor объекта Application.DocumentManager.MdiActiveDocument 
            Editor ed = Application.DocumentManager.MdiActiveDocument.Editor;

            // 5. Добавим try/catch блок. 
            // Заметка: поместим “}” блока try после шага 11.
            // Поместите ниже блок catch с “}” после шага 12
            try
            {
                // 6. Присвоим переменной ContextMenuExtension из шага 2 значение 
                // new ContextMenuExtension 
                myContextMenu = new ContextMenuExtension();

                // 7. Присвоим свойству Title объекта ContextMenuExtension 
                // значение "Circle Jig". (для вызова команды, завершенной в Lab7). 
                myContextMenu.Title = "Circle Jig";

                // 8. Объявим переменную типа MenuItem с именем mi. Присвоим ей значение 
                // new MenuItem. В качестве строчного параметра используем строку 
                // "Run Circle Jig". 
                MenuItem mi = new MenuItem("Run Circle Jig");

                // 9. Контекстное меню работает таким образом, что каждому пункту меню мы 
                // ставим в соответствие специальную функцию-член, которая вызывается при выборе пункта меню 
                // Используем событие MenuItem Click (mi.Click += ) чтобы указать, что 
                // функция с именем CallbackOnClick будет обрабатывать события выбора пункта меню. 
                // Вы создадите её на шагах 20 - 22 
                mi.Click += CallbackOnClick;

                // 10. Используем метод Add коллекции MenuItems объекта 
                // ContextMenuExtension, созданного на шаге 6. Передаём 
                // MenuItem созданный на шаге 8. 
                myContextMenu.MenuItems.Add(mi);

                // 11. Используем метод AddDefaultContextMenuExtension объекта Application. 
                // Передаём в ContextMenuExtension 
                Application.AddDefaultContextMenuExtension(myContextMenu);
            }
            catch (Exception ex)
            {
                // 12. Используем переменную типа Editor из шага 4 и печатаем сообщение 
                // в командную строку: 
                // "Error Adding Context Menu: " + ex.Message 
                ed.WriteMessage("Error Adding Context Menu: " + ex.Message);
            }
        }

        // 13. Создаём функцию с именем RemoveContextMenu. 
        // Заметка: Поместим “}” после шага 19. 
        public void RemoveContextMenu()
        {

            // 14. Объявим переменную типа Editor. Присвоим ей значение, возвращаемое 
            // свойством Editor объекта MdiActiveDocument 
            Editor ed = Application.DocumentManager.MdiActiveDocument.Editor;

            // 15. Добавим try/catch блок. 
            // Заметка: поместим “}” блока try после шага 18.
            // поместим catch после неё. Поместим “}” блока catch сразу после 
            // шага 19.
            try
            {
                // 16. Используем оператор "if" и проверим не равна ли ContextMenuExtension 
                // объявленная на шаге 2, значению null (!=)
                // Заметка: поместим “}” после шага 18 
                if (myContextMenu != null)
                {
                    // 17. В блоке "if", используем метод RemoveDefaultContextMenuExtension 
                    // объекта Application. Передаём ему переменную ContextMenuExtension, 
                    // объявленную на шаге 2
                    Application.RemoveDefaultContextMenuExtension(myContextMenu);

                    // 18. Присваиваем переменной ContextMenuExtension, объявленной на шаге 2, null 
                    myContextMenu = null;

                }
            }
            catch (Exception ex)
            {
                // 19. Используем объект Editor для печати сообщения: 
                // "Error Removing Context Menu: " + ex.Message 
                ed.WriteMessage("Error Removing Context Menu: " + ex.Message);
            }
        }

        // 20. Создаём частную функцию (private void) с именем CallbackOnClick. Эта функция
        // будет вызываться, когда выбирается пункт меню. Устанавливается на шаге 9. 
        // Заметка: Поместим “}” после шага 22. 
        private void CallbackOnClick(object Sender, System.EventArgs e)
        {
            // 21. Используем оператор using и создаём переменную типа DocumentLock. 
            // Присваиваем ей значение, возвращаемое методом MdiActiveDocument.LockDocument 
            // (Т.к. это событие выполняется вне контекста документа, нам нужно заблокировать документ) 
            // Так реализовано в AutoCAD, что данные хранящиеся в его документах
            // могут модифицировать команды, которые выполняются в контексте этих документов.
            // Когда мы выполняем наш код как реакцию на контекстное меню, 
            // мы получаем доступ к документу из вне контекста документа. 
            // Чтобы разблокировать документ достаточно просто удалить (метод Dispose) объект DocumentLock, 
            // который вернул запрос на блокировку документа.
            // Заметка: поместим “}” оператора using после шага 22. 
            using (DocumentLock docLock = Application.DocumentManager.MdiActiveDocument.LockDocument())
            {
                // 22. Вызываем функцию CircleJig(). 
                CircleJig();
                // Добавим после шага 25 
                //acedPostCommand("CANCELCMD");

                if (is64bits)
                {
                    acedPostCommand64("CANCELCMD");
                }
                else
                {
                    acedPostCommand32("CANCELCMD");
                }

                acedPostCommandPrompt();

            }
        }

        public void Initialize()
        {
            // 23. Внутри функции Initialize (созданной на шаге 1) добавим вызов 
            // AddContextMenu(). Это приведет к тому, что на этапе загрузки .NET dll
            // будет добавлено контекстное меню 
            // Note: Переходим к шагу 24 (ниже) 
            AddContextMenu();

            // 37. Внутри функции Initialize. Раскомментируйте эту строку после шагов 24 - 27 
            // Это будет выполнено, когда dll будет загружена в AutoCAD 
            // AddTabDialog();
            AddTabDialog();
        }

        public void Terminate()
        {
            // 24. Внутри функции Terminate. (созданной на шаге) добавьте вызов 
            // RemoveContextMenu(). 
            // Перед тем, как перейти к шагу 24, постройте (Build) проект и загрузите (Netload) dll. 
            // Правый клик в области чертежа. Вы должны увидеть новый пункт меню "Circle Jig" 
            RemoveContextMenu();
        }


        [DllImport("acad.exe", CharSet = CharSet.Unicode, EntryPoint = "?acedPostCommand@@YAHPB_W@Z")]
        public static extern bool acedPostCommand32(string cmd);

        [DllImport("acad.exe", CharSet = CharSet.Unicode, EntryPoint = "?acedPostCommand@@YAHPEB_W@Z")]
        public static extern bool acedPostCommand64(string cmd);
        
        [DllImport("acad.exe", EntryPoint="acedPostCommandPrompt")]
        public static extern void acedPostCommandPrompt();
        

        //check the OS (32 or 64 bits)
        static public bool is64bits
        {
            get
            {
                // return (Application.GetSystemVariable("PLATFORM").ToString().IndexOf("64") > 0);
                return System.IntPtr.Size > 4;
            }
        }

        // 25. Раскомментируйте это чтобы снять проблемы с командной строкой, 
        // чтобы привести её в нормальное состояние после выполнения пункта меню 
        // using System.Runtime.InteropServices; //(перенесите вне класса – нужно для P/Invoke) 
        // acedPostCommand("CANCELCMD") // Перенесите это после CircleJig() в шаге 22 
        // [DllImport("acad.exe", CharSet = CharSet.Unicode, EntryPoint = "?acedPostCommand@@YAHPB_W@Z")]
        // public static extern bool acedPostCommand(string cmd);
        // P.S. (примечание переводчика): У меня есть сомнения в том, что для 
        // восстановления командной строки  нужно вызывать эту функцию, а не 
        // acedPostCommandPrompt. 
        // Поэтому вставим и её описание:
        // [DllImport("acad.exe", EntryPoint="acedPostCommandPrompt")]
        // public static extern void acedPostCommandPrompt();
        // acedPostCommandPrompt(); // Перенесите это после CircleJig() на шаге 22


        // Lab8 Шаги 26 - 37. Добавим вкладку в диалог команды _OPTIONS. 
        // Чтобы добавить вкладку, необходимо подписаться на уведомление о том,
        // что диалог _OPTIONS запущен.
        // Это делается путём передачи адреса функции-члена, которая должна вызываться. 
        // Нам нужно также реализовать функцию обратного вызова (callback). 
        // Второй аргумент, который передаётся в функцию обратного вызова, 
        // объект типа TabbedDialogEventArgs, который мы должны использовать 
        // для вызова метода AddTab. AddTab получает строку заголовка и
        // объект типа TabbedDialogExtension, который является «оберткой» формы.
        // Внутрь конструктора класса TabbedDialogExtension, мы передаём новый 
        // экземпляр UserControl (пользовательский контрол), и адрес функции 
        // обратного вызова. Мы можем обрабатывать сообщения OnOK, OnCancel и OnHelp. 

        // 26. Сначала объявим public static переменную типа String. Эта переменная 
        // будет установлена из нашей вкладки в диалоге _OPTIONS 
        // Назовем её "myVariable" 
        public static string myVariable;

        // 27. Добавим public static void функцию с именем AddTabDialog. 
        // Мы будем её вызывать из функции Initialize(), созданной на шаге 1 
        // Заметка: Поместим “}” после шага 28. 
        public static void AddTabDialog()
        {

            // 28. Используем событие объекта Application с именем DisplayingOptionDialog.
            // Используем += чтобы определить функцию, которая будет вызываться
            // когда запускается команда _OPTIONS.
            // Вы создадите эту функцию на шаге 29. (назовём её TabHandler) 
            Application.DisplayingOptionDialog += TabHandler;
        }

        // 29. Создадим private static void функцию с именем TabHandler. Эта функция 
        // будет вызваться, когда диалог _OPTIONS показывается. (Имя должно совпадать
        // с именем параметра Delegate на шаге 28)
        // Первый параметр – объект с именем sender. 
        // Второй параметр типа TabbedDialogEventArgs.
        // Используем Autodesk.AutoCAD.ApplicationServices.TabbedDialogEventArgs e
        // Заметка: Поместим “}” после шага 33 
        private static void TabHandler(object sender, Autodesk.AutoCAD.ApplicationServices.TabbedDialogEventArgs e)
        {

            // 30. Объявим переменную типа UserControl, которую мы ходим добавить к 
            // диалогу _OPTIONS. (myCustomTab) Используем оператор new для её создания. 
            myCustomTab myCustomTab = new myCustomTab();

            // 31. Объявим переменную типа TabbedDialogAction. Создадим её оператором new, 
            // чтобы создать новый объект TabbedDialogAction. В качестве параметра 
            // используем метод OnOk объекта UserControl из шага 29
            // Мы можем подписаться на Да (OK), Отказ (Cancel) и Помощь (Help).
            // В этом примере мы выберем обработку только OK. 
            // Заметка: Метод OnOk будет добавлен в шагах 35 - 36. (Вы можете перейти к этим шагам 
            // в коде пользовательской формы - myCustomTab – и потом вернуться обратно) 
            TabbedDialogAction tabbedDialogAct = new TabbedDialogAction(myCustomTab.OnOk);

            // 32. Объявим переменную типа TabbedDialogExtension. Создадим её оператором new 
            // TabbedDialogExtension. В качестве параметра control передадим переменную UserControl из шага 30 
            // и в качестве параметра TabbedDialogAction передадим переменную типа TabbedDialogAction
            // из шага 31. 
            TabbedDialogExtension tabbedDialogExt = new TabbedDialogExtension(myCustomTab, tabbedDialogAct);

            // 33. Используем метод AddTab объекта типа TabbedDialogEventArgs переданного в событие. 
            // (с именем e). В качестве параметра Name используем "Value for custom variable".
            // В качестве параметра TabbedDialogExtension используем TabbedDialogExtension из шага 32. 
            // Заметка: Переходим к шагу 34 в функции TestTab ниже. 
            e.AddTab("Value for custom variable", tabbedDialogExt);
        }

        // Запустим эту команду для получения значения 
        [CommandMethod("testTab")]
        public void TestTab()
        {
            Editor ed = Application.DocumentManager.MdiActiveDocument.Editor;
            // 34. Раскомментируйте эту строку, чтобы напечатать значение из вкладки,
            // добавленной в предыдущих шагах, в командную строку. 
            // ed.WriteMessage(myVariable.ToString());            
            // Заметка: Вы может понадобится изменить имя myVariable на имя, которое вы использовали на шаге 26 

            // Переходим к шагам 35 - 36 в окне кода UserControl (myCustomTab), 
            // если вы не сделали этого раньше. Также выполните шаг 37, рядом с шагом 23 

            // После того, как шаги 35-36 сделаны, перестройте проект (Build), загрузите dll
            // и выполните команду _OPTIONS, чтобы увидеть пользовательский диалог. 
            // Установите значение в текстовом поле и нажмите Да (OK). Если затем вы выполните 
            // эту команду, вы должны увидеть в командной строке значение, введенное в диалоге _OPTIONS 
            // После этого перейдем к шагам 38-48 в коде 
            // окна для UserControl1. (Добавим функциональность для Drag & Drop). 

            ed.WriteMessage(myVariable.ToString());
        }

        [CommandMethod("addAnEnt")]
        public void AddAnEnt()
        {

            // Получаем объект редактора, чтобы иметь возможность ввода
            Editor ed = Application.DocumentManager.MdiActiveDocument.Editor;

            // Определим тип примитива, который мы хотим создать
            PromptKeywordOptions getWhichEntityOptions = new PromptKeywordOptions("Which entity do you want to create? [Circle/Block] : ", "Circle Block");
            // Теперь введем его
            PromptResult getWhichEntityResult = ed.GetKeywords(getWhichEntityOptions);
            // Если OK
            if ((getWhichEntityResult.Status == PromptStatus.OK))
            {

                // Проверим что требуется
                switch (getWhichEntityResult.StringResult)
                {

                    case "Circle":

                        // Укажем точку центра окружности
                        PromptPointOptions getPointOptions = new PromptPointOptions("Pick Center Point : ");
                        PromptPointResult getPointResult = ed.GetPoint(getPointOptions);
                        // Если OK
                        if ((getPointResult.Status == PromptStatus.OK))
                        {

                            // Получаем радиус
                            PromptDistanceOptions getRadiusOptions = new PromptDistanceOptions("Pick Radius : ");
                            // Установим в качестве базовой точки центр окружности (точку, которую только что указали) 
                            getRadiusOptions.BasePoint = getPointResult.Value;
                            // теперь укажем механизму ввода использовать базовую точку! 
                            getRadiusOptions.UseBasePoint = true;
                            // теперь получаем радиус
                            PromptDoubleResult getRadiusResult = ed.GetDistance(getRadiusOptions);
                            // Если всё OK
                            if ((getRadiusResult.Status == PromptStatus.OK))
                            {
                                // Начало Lab3. Создадим окружность или описание блока и вставку блока 
                                // 1. Объявим переменную класса Database и присвоим ей значение 
                                // используя свойство Document.Database объекта класса Editor, созданного выше. (ed) 
                                // Заметка: Добавим пространство имён Autodesk.AutoCAD.DatabaseServices – пространство имён для Database 
                                // и Transaction, используя ключевое слово using (перед объявлением класса) 
                                Database dwg = ed.Document.Database;

                                // 2. Объявим переменную типа Transaction; создаём её используя 
                                // метод TransactionManager.StartTransaction объекта Database,
                                // созданного на предыдущем шагу.
                                Transaction trans = dwg.TransactionManager.StartTransaction();

                                // 3. Добавим блок try/catch/finally. Поместим try сразу после “}”
                                // в шаге 8. Поместим оператор catch сразу после него.
                                // Поместим  шаг 9 в блок catch. Поместим шаг 10 в блок finally.
                                // (Построим (Build) проект и исправим все ошибки).
                                try
                                {

                                    // 4. Объявим переменную класса Circle и создадим её при помощи конструктора. 
                                    // Используем свойство Value объекта PromptPointResult, созданного в Lab2 
                                    // Lab2 в качестве первого параметра. В качестве второго параметра (нормаль) используем 
                                    // Vector3d.ZAxis. Используем свойство Value объекта PromptDoubleResult 
                                    // (созданного в Lab2) в качестве радиуса. 
                                    // Заметка: Необходимо добавить пространство имён Autodesk.AutoCAD.Geometry для Vector3d.
                                    Circle circle = new Circle(getPointResult.Value, Vector3d.ZAxis, getRadiusResult.Value);

                                    // 5. Объявим переменную типа BlockTableRecord. Присвоим ей значение используя
                                    // метод GetObject переменной типа Transaction созданной на шаге 2. 
                                    // Используем свойство CurrentSpaceId переменной типа Database, созданной на шаге 1 
                                    // в качестве первого параметра (ObjectId) В качестве второго параметра 
                                    // используем OpenMode.ForWrite. Мы добавим окружность или в пространство модели
                                    // (ModelSpace) или в пространство листа (PaperSpace)
                                    // Определяет пространство CurrentSpaceId. 
                                    BlockTableRecord btr = (BlockTableRecord)trans.GetObject(dwg.CurrentSpaceId, OpenMode.ForWrite);

                                    // 6. Добавим  Circle к переменной BlockTableRecord созданной на шаге 5. Используем 
                                    // Метод AppendEntity и передаём ему окружность, созданную на шаге 4. 
                                    btr.AppendEntity(circle);

                                    // 7. Сообщим транзакции о новом объекте для его «автозакрытия» 
                                    // Для этой цели используется метод AddNewlyCreatedDBObject. Первый аргумент - окружность 
                                    // Второй аргумент – true. 
                                    trans.AddNewlyCreatedDBObject(circle, true);

                                    // 8. Завершим транзакцию, вызвав её метод Commit. Если код дошел сюда - 
                                    // значит всё работало правильно. 
                                    trans.Commit();
                                }
                                catch (Exception ex)
                                {
                                    // 9. Объявим переменную типа Exception для catch. 
                                    // (добавим  "(Exception ex)" к блоку catch) 
                                    // Используем метод WriteMessage редактора (ed), созданного в Lab2. 
                                    // Используем "problem due to " + ex.Message в качестве параметра message. 
                                    // Если произойдёт ошибка – детальная информация будет напечатана в командной строке AutoCAD 
                                    ed.WriteMessage("problem due to " + ex.Message);
                                }
                                finally
                                {
                                    // 10. Освободим транзакцию, созданную на шаге 2, вызвав её метод Dispose 
                                    // Здесь мы окажемся независимо от того произошла ошибка или нет! 
                                    trans.Dispose();
                                }
                            }
                        }
                        break;
                    case "Block":

                        // введем имя блока
                        PromptStringOptions blockNameOptions = new PromptStringOptions("Enter name of the Block to create : ");
                        // запретим использование пробелов в имени
                        blockNameOptions.AllowSpaces = false;
                        // получаем имя
                        PromptResult blockNameResult = ed.GetString(blockNameOptions);
                        // Если OK
                        if ((blockNameResult.Status == PromptStatus.OK))
                        {

                            // 11. Объявим переменную типа Database и присвоим ей значение равное
                            // свойству Document.Database переменной ed класса Editor
                            Database dwg = ed.Document.Database;

                            // 12. Объявим переменную типа Transaction и присвоим ей значение 
                            // возвращаемое методом TransactionManager.StartTransaction.
                            Transaction trans = (Transaction)dwg.TransactionManager.StartTransaction();

                            // 13. Добавим блок try/catch/finally. Перенесём “}”
                            // после шага 34. Поместим оператор catch после него.
                            // Заключим шаг 35 в блок catch. Заключим шаг 36 в блок finally.
                            try
                            {

                                // 14. Объявим переменную типа BlockTableRecord. Создаём её оператором new 
                                BlockTableRecord newBlockDef = new BlockTableRecord();

                                // 15. Установим имя BlockTableRecord. Используем свойство 
                                // StringResult переменной типа PromptResult (созданной в Lab2) 
                                newBlockDef.Name = blockNameResult.StringResult;

                                // 16. Объявим переменную типа BlockTable. Присваиваем ей значение, которое возвращает метод 
                                // GetObject объекта транзакции. Используем свойство BlockTableId объекта 
                                // типа Database, созданного на шаге 11 в качестве первого параметра. 
                                // Второй параметр - OpenMode.ForRead. Мы открываем для чтения, чтобы проверить 
                                // нет ли еще блока с таким именем. 
                                BlockTable blockTable = (BlockTable)trans.GetObject(dwg.BlockTableId, OpenMode.ForRead);

                                // 17. Добавим оператор if. Проверяем есть ли блок с таким именем при помощи 
                                // метода Has переменной BlockTable, созданной на шаге 16. В качестве строки 
                                // parameter используем свойство StringResult объекта PromptResult, созданного выше в Lab2. 
                                // Проверим если результат равен false 
                                // Перенесём “}” после шага 34. 
                                if ((blockTable.Has(blockNameResult.StringResult) == false))
                                {

                                    // 18. Блока с таким именем еще нет, так что добавим его. 
                                    // Сначала сделаем BlockTable открытой для записи. Чтобы это сделать - вызовем 
                                    // метод UpgradeOpen() объекта типа BlockTable. (созданного на шаге 16) 
                                    blockTable.UpgradeOpen();

                                    // 19. Добавим  BlockTableRecord, созданную на шаге 14. Используем метод Add 
                                    // объекта BlockTable и передаём BlockTableRecord. 
                                    blockTable.Add(newBlockDef);

                                    // 20. Сообщаем транзакции о новом описании блока, чтобы она его «автозакрыла» 
                                    // Используем метод AddNewlyCreatedDBObject транзакции. Первый аргумент 
                                    // BlockTableRecord. Второй аргумент true. 
                                    trans.AddNewlyCreatedDBObject(newBlockDef, true);

                                    // 21. На следующих двух шагах добавим окружности к BlockTableRecord. 
                                    // Объявим переменную класса Circle и создадим её оператором 
                                    // new Circle. В качестве первого аргумента 
                                    // new Point3d(0,0,0), в качестве второго аргумента Vector3d.ZAxis, 
                                    // аргумент Radius равный 10. 
                                    Circle circle1 = new Circle(new Point3d(0, 0, 0), Vector3d.ZAxis, 10);

                                    // 22. Добавим окружность к BlockTableRecord. 
                                    // Используем метод AppendEntity, передаём окружность из шага 21 
                                    newBlockDef.AppendEntity(circle1);

                                    // 23. Добавим другую окружность к BlockTableRecord 
                                    // Объявим переменную класса Circle и создадим её при помощи оператора 
                                    // new. В качестве первого аргумента new Point3d(20,10,0), второй аргумент Vector3d.ZAxis, 
                                    // используем 10 в качестве аргумента Radius. 
                                    Circle circle2 = new Circle(new Point3d(20, 10, 0), Vector3d.ZAxis, 10);

                                    // 24. Добавим вторую окружность к BlockTableRecord. 
                                    // Используем метод AppendEntity и передаём окружность из шага 23 
                                    newBlockDef.AppendEntity(circle2);

                                    // 25. Сообщим транзакции о новых объектах, чтобы она их «автозакрыла» 
                                    // Вызовем для этого метод AddNewlyCreatedDBObject, передаём ему окружность 
                                    // созданный на шаге 21. Делаем это снова для окружности, созданной на шаге 23 
                                    // (используем true как второй аргумент). 

                                    trans.AddNewlyCreatedDBObject(circle1, true);
                                    trans.AddNewlyCreatedDBObject(circle2, true);


                                    // 26. Теперь мы используем этот блок и добавим BlockReference к текущему пространству. 
                                    // Сначала объявим переменную типа PromptPointOptions и создадим её при помощи 
                                    // оператора new. В качестве параметра message используем "Pick insertion point of BlockRef : " 
                                    PromptPointOptions blockRefPointOptions = new PromptPointOptions("Pick insertion point of BlockRef : ");

                                    // 27. Объявим переменную типа PromptPointResult. Используем метод GetPoint объекта 
                                    // Editor созданного в Lab2 (ed). Передаём PromptPointOptions, созданную на шаге 26
                                    PromptPointResult blockRefPointResult = ed.GetPoint(blockRefPointOptions);

                                    // 28. Создаём оператор if и проверяем свойство Status переменной PromptPointResult. 
                                    // Проверим равно ли оно PromptStatus.OK. 
                                    // Поместим “}” после шага 30. 
                                    if ((blockRefPointResult.Status != PromptStatus.OK))
                                    {

                                        // 29. Если мы попали сюда, значит метод GetPoint не удался. Вызовем метод 
                                        // dispose объекта  Transaction, созданной на шаге 11. 

                                        trans.Dispose();
                                        // 30. return 
                                        return;
                                    }

                                    // 31. Объявим переменную типа BlockReference. Создадим её при помощи оператора new 
                                    // Используем метод Value объекта PromptPointResult в качестве аргумента Position. (Point3d) 
                                    // Используем свойство ObjectId объекта BlockTableRecord, созданного на шаге 14 
                                    // в качестве второго параметра. 
                                    BlockReference blockRef = new BlockReference(blockRefPointResult.Value, newBlockDef.ObjectId);

                                    // 32. Получаем текущее пространство. (или ModelSpace или PaperSpace). 
                                    // Объявим переменную типа BlockTableRecord, создаем её используя метод GetObject 
                                    // транзакции, созданной на шаге 12. Используем свойство CurrentSpaceId 
                                    // объекта Database, созданной на шаге 11. Открываем её на запись. (OpenMode.ForWrite) 
                                    BlockTableRecord curSpace = (BlockTableRecord)trans.GetObject(dwg.CurrentSpaceId, OpenMode.ForWrite);

                                    // 33. Используем метод AppendEntity объекта BlockTableRecord, созданного на шаге 32 
                                    // и передаём BlockReference, созданный на шаге 31. 

                                    curSpace.AppendEntity(blockRef);

                                    // 34. Сообщим транзакции о новой вставке блока, чтобы транзакция его «автозакрыла» 
                                    // Используем метод AddNewlyCreatedDBObject транзакции, созданной на шаге 12 
                                    // Передаём ему BlockReference. Используем true в качестве второго параметра. 
                                    trans.AddNewlyCreatedDBObject(blockRef, true);

                                    // 35. Если мы попали сюда, значит всё в порядке! 
                                    // Завершим транзакцию, вызвав метод Commit 
                                    trans.Commit();
                                }
                            }
                            catch (Exception ex)
                            {
                                // 36. Объявим переменную типа Exception для catch. 
                                // (добавим "(Exception ex)" к ключевому слову catch) 
                                // Используем метод WriteMessage редактора (ed) созданного в Lab2. 
                                // Используем строку "a problem occurred because " + ex.Message в качестве . 
                                // параметра Message. Если ошибка произошла, её детали будут напечатаны 
                                // в командной строке AutoCAD. 
                                ed.WriteMessage("a problem occurred because " + ex.Message);
                            }
                            finally
                            {
                                // 37. Освободим транзакцию, созданной на шаге 12, путём вызова метода Dispose 
                                // Это произойдет независимо от того произошли ли ошибки или нет 
                                // Это конец Lab3.
                                // Построим приложение (Build) и отладим путем загрузки в AutoCAD.
                                // (команда NETLOAD) и выполним команду addAnEnt.
                                trans.Dispose();
                            }
                        }
                        break;
                }

            }
        }

        // 1. Используем ссылку на PresentationCore. (Используем вкладку .NET 
        // в диалоге Add Reference. Это необходимо для PaletteSet 
        // которую мы объявим на шаге 3. 

        // 2. Используем директиву using для пространства имён Autodesk.AutoCAD.Windows 

        // 3. Объявим переменную PaletteSet (глобальную) как PaletteSet. (она будет 
        // создана только один раз). Добавим это объявление после функции AddAnEnt из Lab 3. 

        public PaletteSet myPaletteSet;

        // 4. Объявим переменную типа UserControl1. Этот контрол создан 
        // перед шагами. Этот контрол будет размещен на 
        // PaletteSet объявленной на шаге 3. Необходимо использовать 
        // пространство имён UserControl1 в объявлении. (Lab4)
        public UserControl1 myPalette;

        // 5. Добавим новую команду с именем “palette”. Используем атрибут
        // CommandMethod и создаём функцию, которая будет выполнятся при вызове команды
        // Заметка: Поместите “}” после шага 10. 
        [CommandMethod("palette")]
        public void palette()
        {

            // 6. Добавим оператор "if" и проверим, равна ли переменная типа 
            // PaletteSet, объявленная на шаге 3, null. Она будет 
            // null при первом запуске команды. 
            // Заметка: Поместите “}” после шага 9. 
            if (myPaletteSet == null)
            {

                // 7. Если PaletteSet равна null – создадим новый PaletteSet, 
                // с уникальным GUID. Используем оператор new. Параметр Name 
                // сделаем "My Palette". В качестве параметра ToolID генерируем новый GUID. 
                // В меню Tools выберите "Create Guid". В диалоге "Create GUID" 
                // выберите "Registry Format" Выберите новый GUID и скопируйте. 
                // Вставьте GUID для использования как новый System.Guid. 
                // Замените фигурные скобки на двойные кавычки (параметр для GUID
                // строковый)
                myPaletteSet = new PaletteSet("My Palette", new System.Guid("D61D0875-A507-4b73-8B5F-9266BEACD596"));

                // 8. Создаём переменную UserControl1, объявленную на шаге 4 
                // Используем оператор new. (new UserControl1 – необходимо 
                // указать и пространство имён) 
                // Этот контрол содержит TreeView контрол. 
                myPalette = new UserControl1();

                // 9. Добавим UserControl к PaletteSet. Используем метод Add method 
                // объекта PaletteSet, созданного на шаге 7. Используем "Palette1" 
                // в качестве параметра имени и, созданный на шаге 8, 
                // контрол в качестве второго параметра
                myPaletteSet.Add("Palette1", myPalette);
            }

            // 10. Покажем paletteset, установив её свойству Visible 
            // значение true. При втором запуске команды 
            // только этот код будет выполнен. 
            myPaletteSet.Visible = true;
        }

        // 11. Добавим команду с именем "addDBEvents. Используем атрибут CommandMethod 
        // и добавим функцию, которая выполнит код, когда команда запущена 
        // Заметка: Поместите “}” после шага 20 
        [CommandMethod("addDBEvents")]
        public void addDBEvents()
        {

            // 12. Используем оператор if чтобы проверить равна ли null 
            // переменная palette, созданная на шаге 4. 
            // Заметка: Поместите “}” после шага 15 
            if (myPalette == null)
            {
                // 13. Объявим и инициализируем объект типа Editor. Используем 
                // свойство Editor объекта Application.DocumentManager.MdiActiveDocument 
                Editor ed = Application.DocumentManager.MdiActiveDocument.Editor;

                // 14. Используем метод WriteMessage переменной типа Editor, 
                // созданной на шаге 13. Используем в качестве параметра message 
                // "\n" + "Please call the 'palette' command first" 
                ed.WriteMessage("\n" + "Please call the 'palette' command first");

                // 15. return
                return;
            }

            // 16. Объявим переменную типа Database и присвоим ей значение 
            // свойство Database объекта 
            // Application.DocumentManager.MdiActiveDocument 

            Database curDwg = Application.DocumentManager.MdiActiveDocument.Database;

            // 17. Подпишемся на событие ObjectAppended. Используем событие ObjectAppended
            // переменной типа Database, созданной на шаге 16. Используем
            // оператор += и оператор new для создания нового ObjectEventHandler.
            // В качестве параметра цели используется/ имя функции, 
            // которую мы создадим на шаге 21.
            // (callback_ObjectAppended).

            curDwg.ObjectAppended += new ObjectEventHandler(callback_ObjectAppended);

            // 18. Подпишемся на событие ObjectErased. Используем событие ObjectErased
            // переменной типа Database, созданной на шаге 16. Используем
            // оператор += и оператор new для создания нового ObjectErasedEventHandler. 
            // В качестве параметра цели используется
            // имя функции, которую мы создадим на шаге 24.
            // (callback_ObjectErased).
            curDwg.ObjectErased += new ObjectErasedEventHandler(callback_ObjectErased);

            // 19. Подписываемся на событие ObjectReappended. Используем событие ObjectReappended
            // переменной типа Database, созданной на шаге 16. Используем
            // оператор += и оператор new для создания нового ObjectEventHandler. 
            // В качестве параметра цели используется
            // имя функции, которую мы создадим на шаге 32.
            // (callback_ObjectReappended).
            curDwg.ObjectReappended += new ObjectEventHandler(callback_ObjectReappended);

            // 20. Подписываемся на событие ObjectUnappended. Используем событие ObjectUnappended
            // переменной типа Database, созданной на шаге 16. Используем
            // оператор += и оператор new для создания нового ObjectEventHandler. 
            // В качестве параметра цели используется
            // имя функции, которую мы создадим на шаге 35.
            // (callback_ObjectUnappended).
            curDwg.ObjectUnappended += new ObjectEventHandler(callback_ObjectUnappended);
        }

        // 21. Создадим частную (private) функцию с именем callback_ObjectAppended. (возвращающую void)
        // Эта функция будет вызываться, когда объекты будут добавляться 
        // к Database (Имя должно совпадать с именем параметра Delegate из шага 17
        // Первый параметр – объект (object) (зададим ему имя sender)
        // Второй параметр типа ObjectEventArgs (зададим ему имя e)
        // Заметка: Поместим “}” после шага 23 
        private void callback_ObjectAppended(object sender, ObjectEventArgs e)
        {

            // 22. Объявим переменную типа TreeNode (System.Windows.Forms.TreeNode). 
            // Заметка: Можно сократить текст программы, если использовать директиву using с именем пространства имён. 
            // Создадим её (переменную) используя метод Add свойства Nodes объекта TreeView в 
            // UserControl(), созданного на шаге 4. Используем параметр 
            // ObjectEventArgs, переданный в функцию в качестве строкового 
            // параметра и используем тип DBObject. (e.DBObject.GetType().ToString()) 
            System.Windows.Forms.TreeNode newNode = myPalette.treeView1.Nodes.Add(e.DBObject.GetType().ToString());

            // 23. Присваиваем свойство Tag для node, созданного на шаге 22 
            // равное ObjectId добавляемого объект 
            // Это позволит нам записать его ObjectId для распознавания в других событиях 
            // Используем e.DBObject.ObjectId.ToString() 
            newNode.Tag = e.DBObject.ObjectId.ToString();
        }

        // 24. Создадим частную (private) функцию с именем callback_ObjectErased. (возвращающую void)
        // Эта функция будет вызываться, когда объекты будут удалятся из 
        // Database (Имя должно совпадать с именем параметра Delegate из шага 18
        // Первый параметр – объект (object) (зададим ему имя sender)
        // Второй параметр типа ObjectErasedEventArgs (зададим ему имя e)
        // Заметка: Поместим “}” после шага 32 
        private void callback_ObjectErased(object sender, ObjectErasedEventArgs e)
        {

            // 25. Используем оператор "if else"  и проверяем свойство Erased объекта 
            // ObjectErasedEventArgs переданного в функцию. (e.Erased) 
            // Заметка: Поместим “}” и оператор "else" перед шагом 30. 
            // Поместим “}” для "else" после шага 31 
            if (e.Erased)
            {

                // 26. Будем искать объект в контроле TreeView, чтобы его оттуда удалить. 
                // Запишем оператор foreach. Используем node в качестве имени элемента цикла
                // типа System.Windows.Forms.Treenode. Параметр коллекции – свойство Nodes в TreeView. 
                // (myPalette.treeView1.Nodes) 
                // Заметка: Поместим “}” после шага 29 
                foreach (System.Windows.Forms.TreeNode node in myPalette.treeView1.Nodes)
                {
                    // 27. Используем оператор "if". Проверим, что свойств Tag объекта node равен the ObjectId 
                    // удалённого объекта. Используем свойство DBObject объекта 
                    // ObjectErasedEventArgs, переданного в событие. (e.DBObject.ObjectId.ToString()) 
                    // Заметка: Поместите “}” над “}” цикла 
                    if (node.Tag.ToString() == e.DBObject.ObjectId.ToString())
                    {

                        // 28. Удалим node вызовом метода Remove. (Примитив был удалён из чертежа) 
                        node.Remove();

                        // 29. Завершим цикл оператором break. 
                        break;
                    }

                }
            }
            else
            {
                // 30. Если мы попали сюда, то объект был восстановлен (unerased). (e.Erased равно false) 
                // Объявим переменную типа System.Windows.Forms.TreeNode с именем newNode
                // Создаём её методом Add коллекции Nodes объекта TreeView, созданного ранее. 
                // Используем тип объекта в качестве параметра. 
                // e.DBObject.GetType().ToString() 
                System.Windows.Forms.TreeNode newNode = myPalette.treeView1.Nodes.Add(e.DBObject.GetType().ToString());

                // 31. Присваиваем свойству Tag объекта newNode, созданного на шаге 30, равного ObjectId 
                // восстановленного объекта. Это позволит записать ObjectId для распознавания 
                // в других событиях. Используем e.DBObject.ObjectId.ToString() 
                newNode.Tag = e.DBObject.ObjectId.ToString();
            }
        }

        // 32. Создаём частную функцию с именем callback_ObjectReappended. Эта функция 
        // будет вызываться, когда объект повторно добавляется (ReAppended) к базе. 
        // (Имя должно совпадать с именем параметра Delegate на шаге 19). 
        // Первый параметр - объект. (Используем имя sender). Второй параметр 
        // ObjectEventArgs. (используем e в качестве его имени) 
        // Заметка: Поместим “}” после шага 34 
        private void callback_ObjectReappended(object sender, ObjectEventArgs e)
        {

            // 33. Добавим имя класса объекта к контролу TreeView 
            // Объявим переменную типа TreeNode. (System.Windows.Forms.TreeNode). 
            // Присваиваем ей значение используя метод Add свойства Nodes контрола TreeView на UserForm1, 
            // создано на шаге 4. Используем ObjectEventArgs, переданный в метод в качестве
            // строкового параметра parameter и используем тип DBObject. 
            //(e.DBObject.GetType().ToString()) 
            System.Windows.Forms.TreeNode newNode = myPalette.treeView1.Nodes.Add(e.DBObject.GetType().ToString());

            // 34. Записываем его ID для дальнейшего опознания 
            // Присваиваем свойству Tag для node, созданного на шаге 33, значение равное ObjectId
            // восстановленного объекта. Это позволит нам записать его ObjectId для распознавания 
            // в других событиях. Используем e.DBObject.ObjectId.ToString() 
            newNode.Tag = e.DBObject.ObjectId.ToString();
        }

        // 35. Создаем частную функцию с именем callback_ObjectUnappended. (возвращающую void) Эта функция
        // будет вызываться, когда объект исключается (UnAppended) из базы. 
        // (Имя должно быть таким же, как имя параметра Delegate на шаге 20). 
        // Первый параметр - объект. (Используем имя sender). 
        // Второй параметр - ObjectEventArgs. (Используем имя e) 
        // Заметка: Поместим “}” после шага 39 
        private void callback_ObjectUnappended(object sender, ObjectEventArgs e)
        {

            // 36. Здесь мы поищем объект в контроле TreeView, чтобы его удалить. 
            // Создаём оператор foreach. В качестве элемента цикла используем имя node и тип 
            // System.Windows.Forms.TreeNode. Параметр коллекция - свойство Nodes объекта TreeView. 
            // (myPalette.treeView1.Nodes) 
            // Заметка: Поместим “}” после шага 39  
            foreach (System.Windows.Forms.TreeNode node in myPalette.treeView1.Nodes)
            {
                // 37. Используем оператор "if" и сравниваем node.Tag с ObjectId. 
                // (Используем e.DBObject.ObjectId.ToString) 
                // Заметка: Поместим “}” после шага 39  
                if (node.Tag.ToString() == e.DBObject.ObjectId.ToString())
                {
                    // 38. Если мы попали сюда, тогда мы нашли node для unappended объекта. 
                    // Вызываем метод Remove для node. 
                    node.Remove();

                    // 39. Выходим из цикла при помощи break.
                    break;
                }

            }
        }

        [CommandMethod("addData")]
        public void addData()
        {

            // получаем объект редактора
            Editor ed = Application.DocumentManager.MdiActiveDocument.Editor;
            // укажем примитив для добавления данных 
            PromptEntityResult getEntityResult = ed.GetEntity("Pick an entity to add an Extension Dictionary to : ");
            // Если всё OK
            if ((getEntityResult.Status == PromptStatus.OK))
            {
                // стартуем транзакцию
                Transaction trans = ed.Document.Database.TransactionManager.StartTransaction();
                try
                {

                    // Начало Lab5 
                    // Добавим данные к выбранному объекту. 

                    // 1. Объявим переменную типа Entity с именем ent. Создадим её 
                    // используя метод GetObject объекта транзакции (trans) В качестве 
                    // параметра ObjectId используем свойство ObjectId 
                    // объекта PromptEntityResult, созданного выше (getEntityResult) 
                    // Открываем объект для чтения. 

                    Entity ent = (Entity)trans.GetObject(getEntityResult.ObjectId, OpenMode.ForRead);

                    // 2. Используем оператор "if" и проверяем свойство IsNull для 
                    // ExtensionDictionary объекта ent. Если оно IsNull, тогда 
                    // создаём ExtensionDictionary. 
                    // Заметка: Поместим “}” после шага 4. 
                    if (ent.ExtensionDictionary.IsNull)
                    {
                        // 3. Переключаем примитив в режим для записи. Т.к. у него нет расширенного словаря 
                        // и мы хотим его добавить, ent должно быть открыто для записи 
                        ent.UpgradeOpen();

                        // 4. Создаём ExtensionDictionary вызвав метод 
                        // CreateExtensionDictionary примитива ent. 
                        ent.CreateExtensionDictionary();
                    }

                    // 5. Объявим переменную типа DBDictionary. Создаём её используя метод 
                    // GetObject объекта транзакции (trans). В качестве параметра 
                    // ObjectId используем свойство ExtensionDictionary примитива ent 
                    // полученного на шаге 1. Открываем его для чтения 
                    DBDictionary extensionDict = (DBDictionary)trans.GetObject(ent.ExtensionDictionary, OpenMode.ForRead);

                    // 6. Проверим нет ли еще записи, которую мы хотим добавить к словарю 
                    // Используем свойство Contains словаря в операторе "if else"
                    // Заметка: Поместим “}” и "else" после шага 12.
                    // Поместим “}” оператора else после шага 25
                    if (extensionDict.Contains("MyData"))
                    {
                        // 7. Объявим переменную типа ObjectId с именем entryId и присвоим ей значение, используя метод
                        // GetAt объекта ExtenstionDictionary из шага 5. Используем
                        // "Mydata" в качестве entryName
                        ObjectId entryId = extensionDict.GetAt("MyData");

                        // 8. Если мы сюда попали, значит у примитива уже есть данные, которые мы собирались добавить 
                        // Используем метод WriteMessage объекта Editor (ed) для печати данных 
                        // В качестве строки аргументов используем: 
                        // "\nThis entity already has data..." 
                        ed.WriteMessage("\nThis entity already has data...");

                        // 9. Теперь извлечем Xrecord. Объявим переменную типа Xrecord. 
                        Xrecord myXrecord = default(Xrecord);

                        // 10. Инициализируем переменную Xrecord используя метод 
                        // GetObject объекта Transaction (trans). 
                        // В качестве аргумента ObjectId используем ObjectId, созданный на шаге 7
                        // Открываем для чтения.
                        myXrecord = (Xrecord)trans.GetObject(entryId, OpenMode.ForRead);

                        // 11. Напечатаем значения из Xrecord в командную строку. 
                        // Используем оператор "foreach". В качестве элемента цикла используем имя value, тип TypedValue. 
                        // В качестве коллекции используем свойство Data объекта Xrecord 
                        // Заметка: Поместим “}” после шага 12 
                        foreach (TypedValue value in myXrecord.Data)
                        {

                            // 12. Используем метод WriteMessage объекта Editor (ed). 
                            // В качестве строкового параметра: 
                            // "\n" + value.TypeCode.ToString() + " . " + value.Value.ToString() 
                            ed.WriteMessage("\n" + value.TypeCode.ToString() + " . " + value.Value.ToString());

                        }
                    }
                    else
                    {
                        // 13. Если мы попали сюда, значит данных еще нет – добавим их 
                        // Переключаем ExtensionDictionary в режим для записи 
                        // при помощи метода UpgradeOpen() 
                        extensionDict.UpgradeOpen();

                        System.Type t = typeof(DBDictionary);


                        // 14. Создаём новую Xrecord. Объявим переменную типа Xrecord и присвоим значение new Xrecord 
                        Xrecord myXrecord = new Xrecord();

                        // 15. Создаём список буферов. Объявим переменную типа ResultBuffer. 
                        // Создаём её оператором new. В параметра используем следующее: 
                        //new TypedValue((int)DxfCode.Int16, 1),
                        //new TypedValue((int)DxfCode.Text, "MyStockData"),
                        //new TypedValue((int)DxfCode.Real, 51.9),
                        //new TypedValue((int)DxfCode.Real, 100.0),
                        //new TypedValue((int)DxfCode.Real, 320.6)
                        ResultBuffer data = new ResultBuffer(new TypedValue((int)DxfCode.Int16, 1),
                            new TypedValue((int)DxfCode.Text, "MyStockData"),
                            new TypedValue((int)DxfCode.Real, 51.9),
                            new TypedValue((int)DxfCode.Real, 100.0),
                            new TypedValue((int)DxfCode.Real, 320.6));

                        // 16. Добавим это ResultBuffer к Xrecord используя её свойство Data 
                        // (приравниваем его значению ResultBuffer из шага 15)
                        myXrecord.Data = data;

                        // 17. Создаём запись в ExtensionDictionary. Используем метод SetAt 
                        // объекта ExtensionDictionary из шага 5. В качестве аргумента SearchKey 
                        // используем "MyData". В качестве аргумента DBObject используем Xrecord 
                        // созданный на шаге 14. 
                        extensionDict.SetAt("MyData", myXrecord);

                        // 18. Сообщим транзакции о новом объекте Xrecord для его «автозакрытия» Xrecord 
                        // используем метод AddNewlyCreatedDBObject транзакции (trans) 
                        trans.AddNewlyCreatedDBObject(myXrecord, true);

                        // 19. Здесь мы добавим в TreeView контрол новые данные 
                        // Используем оператор "if" для того, чтобы проверить не равна ли 
                        // палитра (myPalette созданная в Lab 4) не равна null. 
                        // (Если равна, то получим аварийное завершение) 
                        // Заметка: Поместим “}” после шага 25 
                        if (myPalette != null)
                        {

                            // 20. Создадим оператор foreach. В качестве элемента - node типа 
                            // System.Windows.Forms.Treenode. В качестве коллекции - свойство объекта
                            // TreeView. (myPalette.treeView1.Nodes) 
                            // Заметка: поместим “}” после шага 25 
                            foreach (System.Windows.Forms.TreeNode node in myPalette.treeView1.Nodes)
                            {

                                // 21. Используем оператор "if". Проверим равенство свойства Tag объекта node и ObjectId 
                                // примитива ent из шага 1. Используем ObjectId. (ent.ObjectId.ToString) 
                                // Заметка: поместим “}” после шага 25 
                                if (node.Tag.ToString() == ent.ObjectId.ToString())
                                {

                                    // 22. Добавим новые к TreeNode. Объявим переменную с именем childNode
                                    // типа System.Windows.Forms.Treenode. 
                                    // Присвоим ей значение возвращаемое вызовом методом Add
                                    // коллекции Nodes объекта node - элемент цикла. 
                                    // (node.Nodes.Add) В качестве строки используем "Extension Dictionary" 
                                    System.Windows.Forms.TreeNode childNode = node.Nodes.Add("Extension Dictionary");

                                    // 23. Теперь добавим данные. Создадим оператор foreach. Используем как элемент имя 
                                    // value  и тип TypedValue. Используем свойство Data объекта Xrecord создано 
                                    // на шаге 14 в качестве коллекции. 
                                    // Заметка: поместим “}” после шага 24 
                                    foreach (TypedValue value in myXrecord.Data)
                                    {
                                        // 24. Добавим TypeValue из цикла к TreeNode, созданному на шаге 22.
                                        // Используем метод Add коллекции Nodes (childNode.Nodes.Add) 
                                        // В качестве аргумента используем TypeValue из цикла. (value.ToString) 
                                        childNode.Nodes.Add(value.ToString());
                                    }

                                    // 25. Выходим из цикла (всё сделано – завершаем цикл) 
                                    break;
                                }
                            }
                        }
                    }

                    // Всё OK, завершаем транзакцию 

                    trans.Commit();
                }
                catch (Exception ex)
                {
                    // Появилась проблема – напечатаем её 
                    ed.WriteMessage("a problem occurred because " + ex.Message);
                }
                finally
                {
                    // Чтобы не случилось нужно освободить транзакцию 
                    trans.Dispose();
                }

            }
        }
        [CommandMethod("addDataToNOD")]
        public void addDataToNOD()
        {

            // получим объект редактора
            Editor ed = Application.DocumentManager.MdiActiveDocument.Editor;
            // стартуем транзакцию
            Transaction trans = ed.Document.Database.TransactionManager.StartTransaction();
            try
            {

                // 26. Здесь мы добавим данные в словарь именованных объектов (Named Objects Dictionary - NOD) 
                // Объявим переменную типа DBDictionary. (назовём её nod). Присвоим ей значение возвращаемое 
                // возвращаемое методом GetObject объекта транзакции 
                // (trans). В качестве аргумента ObjectId используем 
                // свойство NamedObjectsDictionaryId активной базы: 
                // (ed.Document.Database.NamedObjectsDictionaryId) 
                // Открываем для чтения. 

                DBDictionary nod = (DBDictionary)trans.GetObject(ed.Document.Database.NamedObjectsDictionaryId, OpenMode.ForRead);

                // 27. Проверим, не было ли еще такой записи в NOD 
                // Используем свойство Contains словаря в операторе "if else"
                // Заметка: поместим “}” и оператор else после шага 33. Поместим “}” 
                // оператора else после шага 39

                if (nod.Contains("MyData"))
                {

                    // 28. Объявим переменную типа ObjectId с именем entryId. Присвоим ей значение 
                    // равное возвращаемому значению метода GetAt объекта NOD (DBDictionary) 
                    // из шага 26. В качестве аргумента EntryName используем "MyData"
                    ObjectId entryId = nod.GetAt("MyData");

                    // 29. Если мы здесь, значит NOD уже содержит наши данные.
                    // Используем метод WriteMessage редактора. В качестве аргумента Message 
                    // "\n" + "This entity already has data..." 
                    ed.WriteMessage("\n" + "This entity already has data...");

                    // 30. Получаем Xrecord из объекта NOD. Объявим переменную типа Xrecord 
                    Xrecord myXrecord = null;

                    // 31. Используем транзакцию (trans) и используем метод GetObject для получения 
                    // Xrecord из NOD. В качестве аргумента ObjectId используем 
                    // ObjectId из шага 28. Открываем Xrecord для чтения.
                    myXrecord = (Xrecord)trans.GetObject(entryId, OpenMode.ForRead);

                    // 32. Напечатаем значения из Xrecord в командную строку. Используем
                    // оператор "foreach". Используем value в качестве имени элемента цикла
                    // с типом TypedValue. Используем свойство Data объекта Xrecord из
                    // шага 31 в качестве коллекции 
                    // Заметка: поместим “}” после шага 33 
                    foreach (TypedValue value in myXrecord.Data)
                    {
                        // 33. Используем метод WriteMessage редактора. Используем в качестве сообщения: 
                        // "\n" + value.TypeCode.ToString() + " . " + value.Value.ToString() 
                        ed.WriteMessage("\n" + value.TypeCode.ToString() + " . " + value.Value.ToString());

                    }
                }
                else
                {
                    // 34. Наших данных еще нет в NOD, так что нужно добавить его. 
                    // Переключаем переменную NOD с шага 26, в режим записи 
                    nod.UpgradeOpen();

                    // 35. Объявим новую переменную типа Xrecord. 
                    Xrecord myXrecord = new Xrecord();

                    // 36. Создаём список буферов (resbuf). Объявим переменную типа ResultBuffer.
                    // Инициализируем её при помощи new ResultBuffer. 
                    // В качестве аргумента ParamArray используем следующее: 
                    //new TypedValue((int)DxfCode.Int16, 1),
                    //new TypedValue((int)DxfCode.Text, "MyCompanyDefaultSettings"),
                    //new TypedValue((int)DxfCode.Real, 51.9),
                    //new TypedValue((int)DxfCode.Real, 100.0),
                    //new TypedValue((int)DxfCode.Real, 320.6)
                    ResultBuffer data = new ResultBuffer(new TypedValue((int)DxfCode.Int16, 1),
                        new TypedValue((int)DxfCode.Text, "MyCompanyDefaultSettings"),
                        new TypedValue((int)DxfCode.Real, 51.9),
                        new TypedValue((int)DxfCode.Real, 100.0),
                        new TypedValue((int)DxfCode.Real, 320.6));

                    // 37. Добавим ResultBuffer к Xrecord используя свойство Data 
                    // объекта Xrecord. (приравниваем его ResultBuffer из шага 36)
                    myXrecord.Data = data;

                    // 38. Создаём запись в NOD. Используем его метод SetAt 
                    // В качестве аргумента SearchKey используем "MyData".
                    // В качестве аргумента DBObject используем Xrecord, 
                    // созданную на шаге 35. 
                    nod.SetAt("MyData", myXrecord);


                    // 39. Сообщим транзакции о новой Xrecord, используя метод
                    // AddNewlyCreatedDBObject транзакции (trans) 
                    trans.AddNewlyCreatedDBObject(myXrecord, true);
                }

                // Конец Lab 5

                // Всё в порядке – завершим транзакцию 
                trans.Commit();
            }
            catch (Exception ex)
            {
                // Возникла проблема, напечатаем информацию: 
                ed.WriteMessage("a problem occurred because " + ex.Message);
            }
            finally
            {
                // Чтобы не случилось мы должны освободить транзакцию 

                trans.Dispose();

            }
        }

        // Начало Lab6
        // Заметка: На шаге 10 вы добавите tooltip в PointMonitor. 
        // В AutoCAD 2012 есть проблема, что tooltip невидна, если ROLLOVERTIPS = 0
        // Это должно быть исправлено в Service Pack 1. 
        // Так же в AutoCAD 2012 вы можете получить сообщение,
        // когда наводите курсор на примитивы после добавления PointMonitor.
        // (просто проигнорируйте его) Эта проблема передана программистам AutoCAD.

        // 1. Используем атрибут CommandMethod и создаем команду с именем "addpointmonitor"
        // Имя функции startMonitor
        // Заметка: поместим “}” после шага 3

        [CommandMethod("addPointmonitor")]
        public void startMonitor()
        {
            // 2. Объявим переменную типа Editor с именем ed. 
            // Присваиваем ей значение, используя свойство Editor активного документа
            // (Application.DocumentManager.MdiActiveDocument)
            Editor ed = Application.DocumentManager.MdiActiveDocument.Editor;

            // 3. Подписываемся на событие PointMonitor. Используем событие PointMonitor
            // объекта редактора, созданного на шаге 2. Используем 
            // оператор += и оператор new для создания PointMonitorEventHandler. В качестве
            // параметра цели используем имя функции, которую мы создадим на шаге 4.
            // (MyPointMonitor).
            ed.PointMonitor += new PointMonitorEventHandler(MyPointMonitor);
        }

        // 4. Создаём публичную (public) функцию с именем MyPointMonitor.
        // Эта функция будет вызваться при каждом движении мыши 
        // (Имя должно совпадать с именем параметра Delegate из шага 3). 
        // Первый параметр - объект. (Используем имя sender в качестве имени объекта).
        // Тип второго аргумента PointMonitorEventArgs. (Используем e в качестве имени)
        // Заметка: Поместим “}” после шага 26

        public void MyPointMonitor(object sender, PointMonitorEventArgs e)
        {
            if (e.Context == null)
            {
                return;
            }

            // 5. Объявим массив типа FullSubentityPath. В качестве имени массива
            // используем fullEntPath. Присваиваем ему результат метода GetPickedEntities 
            // свойства Context объекта PointMonitorEventArgs переданного в функцию
            FullSubentityPath[] fullEntPath = e.Context.GetPickedEntities();

            // 6. Используем оператор "if" и проверим свойство Length массива, созданного на шаге 5
            // Убедимся, что его значение больше нуля.
            // Заметка: поместим “}” после шага 26
            if (fullEntPath.Length > 0)
            {
                // 7. Объявим переменную с именем trans и типом Transaction. Присваиваем 
                // ей результат метода StartTransaction объекта TransactionManager 
                // активной базы данных. 
                // Application.DocumentManager.MdiActiveDocument.Database.TransactionManager.StartTransaction
                Transaction trans = Application.DocumentManager.MdiActiveDocument.Database.TransactionManager.StartTransaction();

                // 8. Создаём блок try/catch/finally. 
                // Заметка: Поместим операторы catch и finally после шага 25
                // (помещаем шаг 26 в блок finally).
                // Помещаем “}” блока try после шага 26
                try
                {
                    // 9. Объявим переменную типа Entity. Присвоим ей значение 
                    // возвращаемое методом GetObject транзакции, созданной на шаге 7. В качестве
                    // параметра ObjectId используем первый элемент в GetObjectIds()[0] - 
                    // нулевого элемента в массиве FullSubentityPath, созданный на шаге 5
                    // Открываем примитив для чтения
                    Entity ent = (Entity)trans.GetObject((ObjectId)fullEntPath[0].GetObjectIds()[0], OpenMode.ForRead);

                    // 10. Добавим всплывающую подсказку (tooltip) используя метод AppendToolTipText объекта 
                    // PointMonitorEventArgs переданного в эту функцию. 
                    // Используем как аргумент строку:
                    // "The Entity is a " + ent.GetType().ToString()
                    // Заметка: В первой версии AutoCAD 2012 всплывающие подсказки не показываются если
                    // ROLLOVERTIPS = 0
                    e.AppendToolTipText("The Entity is a " + ent.GetType().ToString());

                    // 11. Используем оператор "if" и проверим создана ли палитра (myPalette)
                    // (== null) Если null return из функции.     
                    if (myPalette == null)
                    {
                        return;
                    }

                    // 12. Следующие шаги делают текст для записи DBEntity в палитре, 
                    // созданной в Lab4 полужирной (Bold). Объявим переменную с именем fontRegular
                    // типа System.Drawing.Font. Создаём её оператором new System.Drawing.Font. 
                    // В качестве аргументов используем следующие:
                    // "Microsoft Sans Serif", 8, System.Drawing.FontStyle.Regular
                    System.Drawing.Font fontRegular = new System.Drawing.Font("Microsoft Sans Serif", 8, System.Drawing.FontStyle.Regular);

                    // 13. Объявим переменную с именем fontBold типа System.Drawing.Font. 
                    // Создаём её оператором new System.Drawing.Font. 
                    // В качестве аргументов используем следующие:
                    // "Microsoft Sans Serif", 8, System.Drawing.FontStyle.Bold
                    System.Drawing.Font fontBold = new System.Drawing.Font("Microsoft Sans Serif", 8, System.Drawing.FontStyle.Bold);

                    // 14. Используем метод SuspendLayout() объекта treeView1, созданного в Lab4 
                    // чтобы подождать, пока следующие шаги не будут выполнены. Используем ключевое слово "this"
                    // чтобы получить палитру (myPalette) с TreeView.
                    this.myPalette.treeView1.SuspendLayout();

                    // 15. Теперь найдем объект в контроле TreeView, чтобы изменить шрифт в полужирный 
                    // Создадим оператор foreach. Используем имя node в качестве элемента с типом 
                    // System.Windows.Forms.Treenode. Параметром коллекция будет свойство Nodes в TreeView.
                    // (myPalette.treeView1.Nodes)
                    // Заметка: поместим “}” после шага 21. 
                    // (В этом foreach если курсор над примитивом и если запись для этого примитива есть в
                    // TreeView он будет подсвечен.
                    foreach (System.Windows.Forms.TreeNode node in myPalette.treeView1.Nodes)
                    {
                        //  16. Используем оператор "if else" и смотрим если свойство Tag объекта node
                        //  равна ObjectId примитива, объявленного на шаге 9. 
                        //  (Используем ToString для сравнения)
                        //  Заметка: поместим "else" после шага 19
                        //  Поместим “}” после шага 21. 
                        if (((string)node.Tag == ent.ObjectId.ToString()))
                        {
                            //  17. Если мы попали сюда – значит это node, который нас интересует.
                            //  Используем оператор "if (!...)" и используем метод Equals переменной 
                            //  типа System.Drawing.Font, созданной на шаге 13. В качестве параметра 
                            //  объект используем свойство NodeFont объекта node.
                            //  Заметка: Поместим “}” после шага 19
                            if (!fontBold.Equals(node.NodeFont))
                            {
                                //  18. Присваиваем свойству NodeFont объекта node значение переменной
                                //  типа System.Drawing.Font, созданной на шаге 13.
                                node.NodeFont = fontBold;

                                //  19. Присваиваем свойству Text объекта node его же значение
                                node.Text = node.Text;
                            }
                        }
                        else
                        {
                            //  20. Если мы здесь – это не наш node.
                            //  Используем "if (!...)" и метод Equals объекта 
                            //  System.Drawing.Font, созданного на шаге 12. В качестве параметра объект 
                            //  используем свойство NodeFont объекта node.
                            //  Заметка: Поместим “}” после шага 20.
                            if (!fontRegular.Equals(node.NodeFont))
                            {
                                //  21. Присваиваем свойству NodeFont объекта node значение переменной
                                //  типа System.Drawing.Font, созданной на шаге 12.
                                node.NodeFont = fontRegular;
                            }
                        }
                    }

                    //  22. Теперь время пересчитать TreeView контрол. Используем его метод 
                    //  ResumeLayout(). Используем ключевое слово this для получения палитры
                    //  (myPalette) с TreeView.
                    this.myPalette.treeView1.ResumeLayout();

                    //  23. Освежим TreeView методом Refresh объекта TreeView.
                    this.myPalette.treeView1.Refresh();

                    //  24. Обновим TreView методом Update объекта TreeView.
                    this.myPalette.treeView1.Update();

                    //  25. Всё OK, если мы здесь. Так что завершим транзакцию, созданную на шаге 7
                    trans.Commit();
                }
                catch (Exception ex)
                {

                }
                finally
                {
                    //  26. Чтобы не случилось, а транзакцию нужно освободить. (Т.к. мы в блоке 
                    //  finally). Используем метод Dispose транзакции, созданной в шаге 7.
                    //  Заметка: продолжим на шаге 27 в функции NewInput. Вы можете также построить (Build)
                    //  и проверить команду addPointmonitor перед следующими шагами.
                    trans.Dispose();
                }
            }
        }


        [CommandMethod("newInput")]
        public void NewInput()
        {
            // стартуем InputPointMonitor    
            // получаем объект редактора
            Editor ed = Application.DocumentManager.MdiActiveDocument.Editor;

            // добавим делегат к списку событий
            ed.PointMonitor += new PointMonitorEventHandler(MyInputMonitor);

            // 27. Нужно включить механизм ввода AutoCAD, имитирующий выбор в пределах 
            // апертуры при каждом событии мыши, независимо от того, как точка получается 
            // и какой режим OSNAP сейчас активен. Используем метод TurnForcedPickOn 
            // объекта редактора, созданного выше ("ed")
            ed.TurnForcedPickOn();

            // 28. Здесь запросим у пользователя точку. Объявим переменную типа 
            // PromptPointOptions. Создадим её оператором new PromptPointOptions, 
            // в качестве параметра Message используем "Pick A Point : "
            PromptPointOptions getPointOptions = new PromptPointOptions("Pick A Point : ");

            // 29. Объявим переменную типа PromptPointResult. Присваиваем ей значение,
            // возвращаемое методом GetPoint объекта редактора, созданного выше ("ed"). 
            // Передадим в него переменную PromptPointOptions, созданную на шаге 28.
            PromptPointResult getPointResult = ed.GetPoint(getPointOptions);

            //  Если OK
            //if (getPointResult.Status == PromptStatus.OK)
            //{
            //    //     // делаем что-нибудь...
            //}


            // 30. Теперь удалим наш InputPointMonitor после того, как мы закончили.
            // Используем свойство PointMonitor объекта Editor, созданного выше. ("ed"). 
            // Используем оператор  -= с new PointMonitorEventHandler. В качестве параметра Object
            // используем "MyInputMonitor"
            // Продолжим на шаге 31 в функции MyInputMonitor.
            ed.PointMonitor -= new PointMonitorEventHandler(MyInputMonitor);

        }

        public void MyInputMonitor(object sender, PointMonitorEventArgs e)
        {
            if (e.Context == null)
            {
                return;
            }

            //  сначала проверим что у нас под курсором
            FullSubentityPath[] fullEntPath = e.Context.GetPickedEntities();
            if (fullEntPath.Length > 0)
            {
                //  стартуем транзакцию
                Transaction trans = Application.DocumentManager.MdiActiveDocument.Database.TransactionManager.StartTransaction();
                try
                {
                    //  открываем примитив для чтения, он должен быть наследником Curve
                    Curve ent = (Curve)trans.GetObject(fullEntPath[0].GetObjectIds()[0], OpenMode.ForRead);

                    //  Проверим, что то, над чем курсор имеет расширенный словарь
                    if (ent.ExtensionDictionary.IsValid)
                    {
                        // Откроем его для чтения
                        DBDictionary extensionDict = (DBDictionary)trans.GetObject(ent.ExtensionDictionary, OpenMode.ForRead);

                        // находим запись
                        ObjectId entryId = extensionDict.GetAt("MyData");

                        // Если мы здесь, то всё OK
                        // Извлекаем Xrecord
                        Xrecord myXrecord;

                        //  читаем её из расширенного словаря
                        myXrecord = (Xrecord)trans.GetObject(entryId, OpenMode.ForRead);

                        // 31. Мы будем рисовать временную графику в нескольких позициях вдоль примитива
                        // Создаём цикл "foreach". В качестве элемента используем тип TypedValue
                        // с именем myTypeVal. В качестве коллекции используем свойство Data объекта Xrecord
                        // полученного выше ("myXrecord").
                        // Заметка: поместим “}” после шага 44.
                        foreach (TypedValue myTypedVal in myXrecord.Data)
                        {
                            // 32. Используем оператор "if" и проверяем свойство TypeCode объекта TypedValue
                            // действительное число. (Используем DxfCode.Real для проверки).
                            // Заметка: Поместим “}” после шага 44.
                            if (myTypedVal.TypeCode == (short)DxfCode.Real)
                            {
                                // 33. Разместим временную графику вдоль кривой (Curve) 
                                // Чтобы показать расстояния, нам нужно показать получить точки вдоль кривой.
                                // Заметка: Значения TypedValue будут 51.9, 100.0 и 320.6. 
                                // Эти значения добавлены в Lab 5. Так что длина примитива под курсором 
                                // должна быть длиной как минимум 51.9 единиц
                                // (имейте это в виду при тестировании) 
                                // Объявим переменную типа Point3d object. Присвоим ей значение, возвращаемое методом 
                                // GetPointAtDist примитива ent созданного выше.
                                // В качестве параметра Value используем свойство Value объекта TypedValue

                                Point3d pnt = ent.GetPointAtDist((double)myTypedVal.Value);

                                // 34. Нам нужно узнать сколько пикселей в единичном квадрате,
                                // так чтобы наша временная графика независимо от масштаба изображения (ZOOM)
                                // Объявим переменную типа Point2d с именем pixels. Присвоим ему значение возвращаемое
                                // методом GetNumPixelsInUnitSquare текущего видового порта (Viewport) значение.
                                // (Передаём переменную типа Point3d, созданную на шаге 33).
                                // Используем: e.Context.DrawContext.Viewport.GetNumPixelsInUnitSquare()

                                Point2d pixels = e.Context.DrawContext.Viewport.GetNumPixelsInUnitSquare(pnt);

                                //  35. Нам нужно несколько постоянных расстояний. Объявим переменную типа double
                                //  с именем xDist. Присваиваем ей значение равное 10 деленное на свойство X переменной, 
                                // созданной на шаге 34. 
                                double xDist = (10 / pixels.X);

                                // 36. Объявим переменную типа double с именем yDist. 
                                // Присваиваем ей значение равное 10 деленное на свойство Y переменной типа Point2d из шага 34
                                double yDist = (10 / pixels.Y);

                                // 37. Рисуем временную графику. Объявим переменную типа Circle,
                                // и присвоим ей new Circle. Используем переменную типа Point3d из шага 33
                                // в качестве центра. В качестве нормали использует 
                                // Vector3d.ZAxis. В качестве радиуса используем переменную из шага 35. 
                                Circle circle = new Circle(pnt, Vector3d.ZAxis, xDist);

                                //  38. Используем метод Draw для отображения окружности. (Передаём окружность). 
                                //  Используем:  e.Context.DrawContext.Geometry.Draw()
                                e.Context.DrawContext.Geometry.Draw(circle);

                                // 39. Здесь мы добавим еще временную графику (текст). Объявим переменную
                                // типа DBText. Создаём её оператором new DBText.

                                DBText text = new DBText();

                                // 40. Очень полезно устанавливать тексту, размерам и т.д. значения по умолчанию для базы данных 
                                // Используем метод SetDatabaseDefaults объекта типа из DBText
                                // из шага 39
                                text.SetDatabaseDefaults();

                                // 41. Устанавливаем положение текста в ту же точку, что и центр окружности, 
                                // но смещенную на величину радиуса. Используем свойство Position и присваиваем
                                // ему значение переменной типа Point3d из шага 33 плюс new Vector3d. В качестве
                                // параметра X используем переменную xDist из шага 35. В качестве параметра Y 
                                // используем yDist из шага 36. В качестве Z ноль.
                                text.Position = (pnt + new Vector3d(xDist, yDist, 0));

                                // 42. Используем данные из Xrecord в качестве текста. Используем свойство
                                // примитива из шага 39. Присваиваем ему значение возвращаемое свойством 
                                // Value объекта TypedValue. (используем ToString)
                                text.TextString = myTypedVal.Value.ToString();

                                // 43. Присваиваем свойству Height примитива DBText значение yDist из шага 36 
                                text.Height = yDist;

                                // 44. Используем метод Draw для показа текста. (передаём в него DBText). 
                                // Используем  e.Context.DrawContext.Geometry.Draw()
                                // Заметка: Цвет фона может мешать показу временной графики текста 
                                // (в примере он белый, так что возможно придется поменять цвет фона или изменить цвет DBText)
                                e.Context.DrawContext.Geometry.Draw(text);

                            }
                        }
                        // Конец Lab6

                    }
                    //  Всё OK, завершаем транзакцию
                    trans.Commit();
                }
                catch (Exception ex)
                {
                }
                finally
                {
                    // Чтобы не случилось, а транзакцию нужно освободить
                    trans.Dispose();
                }
            }
        }

        // Создаём команду для вызова EntityJig 
        [CommandMethod("circleJig")]
        public void CircleJig()
        {

            // 39. Создадим новый экземпляр окружности (Circle), которую мы хотим сформировать в jig 
            // Объявим переменную класса Circle с именем circle. Присвоим ему значение 
            // new Circle. В качестве центра используем Point3d.Origin. В качестве нормали 
            // используем Vector3d.ZAxis. Делаем Radius равным 10. 
            Circle circle = new Circle(Point3d.Origin, Vector3d.ZAxis, 10);

            // 40. Создаём новый jig. Объявим переменную new MyCircleJig. 
            // (имя класса созданного на шагах 1-38). Передаём 
            // Circle созданный на шаге 39 
            MyCircleJig jig = new MyCircleJig(circle);

            // 41. Теперь цикл ввода. 0 для положения окружности и 1 для радиуса 
            // Используем цикл с двумя итерациями. 
            // for (int i = 0; i <= 1; i++)
            // Заметка: Поместим “}” после шага 46. 
            for (int i = 0; i <= 1; i++)
            {

                // 42. Присвоим текущему вводу значение индекса цикла. Используем свойство 
                // CurrentInput экземпляра класса, созданного на шаге 40. (делаем её равной 
                // счетчику цикла. (будет или 0 или 1) 
                jig.CurrentInput = i;

                // 43. Получим объект редактора. Объявим переменную типа Editor и присвоим 
                // ей свойство Editor объекта MdiActiveDocument. 
                Autodesk.AutoCAD.EditorInput.Editor ed = Application.DocumentManager.MdiActiveDocument.Editor;

                // 44. Запускаем jig. Объявим переменную типа PromptResult и присвоим ей 
                // значение возвращаемое значение метода Drag объекта типа Editor 
                // созданного на шаге 43. Передадим методу Drag объект класса MyCircleJig, созданного на шаге 40. 
                PromptResult promptResult = ed.Drag(jig);

                // 45. Убедимся, что свойство Status переменной типа PromptResult 
                // созданной на шаге 44 равна OK. Используем оператор "if". Проверим 
                // равно ли promptResult.Status PromptStatus.Cancel или PromptStatus.Error. 
                // Заметка: поместим “}” после шага 46 
                if (promptResult.Status == PromptStatus.Cancel | promptResult.Status == PromptStatus.Error)
                {
                    // 46. Какие-то проблемы. Выход 
                    // Конец Lab 7. 
                    // Заметка: Если вы назвали переменную типа Circle не 
                    // "circle", тогда измените код ниже, который добавляет окружность к базе данных 
                    return;

                }
            }

            // Как только мы закончим с jig, добавим новую окружность к базе данных 
            // Получаем активную базу данных 
            Database dwg = Application.DocumentManager.MdiActiveDocument.Database;

            // стартуем транзакцию 
            Transaction trans = dwg.TransactionManager.StartTransaction();

            try
            {

                // Открываем текущее пространство для записи 
                BlockTableRecord currentSpace = (BlockTableRecord)trans.GetObject(dwg.CurrentSpaceId, OpenMode.ForWrite);

                // добавляем к текущему пространству 
                currentSpace.AppendEntity(circle);

                // сообщим транзакции о новом объекте для «автозакрытия» 
                trans.AddNewlyCreatedDBObject(circle, true);

                // Всё OK, завершим транзакцию 
                trans.Commit();
            }
            catch (Exception ex)
            {
            }
            finally
            {
                // Чтобы не случилось, а транзакцию нужно освободить 
                trans.Dispose();
            }
        }
    }


    // Начало Lab7 
    // Заметка: Этот проект не скомпилируется, пока все шаги лабораторной не будут завершены.
    // Этот код в функции CircleJig требуют объекты, которые создадутся в лабораторной работе. 

    // 1. Создадим класс с именем MyCircleJig, который наследует EntityJig. 
    // Класс EntityJig позволяет динамически создавать ("jig") по одному примитиву за раз. 
    // Когда вы наследуете от EntityJig потребуется переопределить две функции:
    // Функция Sampler используется для ввода данных и функция 
    // Update, которая используются для обновления примитива, который настраивается в jig.
    // В этой лабораторной мы используем Jig для создания окружности. 
    // Заметка: Поместим “}” после шага 38. 

    class MyCircleJig : EntityJig
    {

        // 2. Нам нужно два ввода для окружности – центр и радиус. 
        // Объявим частную (private) переменную-член типа Point3d с именем 
        // "centerPoint" и частную переменную-член типа double с именем "radius". 
        private Point3d centerPoint;
        private double radius;

        // 3. Т.к. нам потребуется два ввода (центр и радиус), нам
        // придется помнить номер ввода. (используем для определения какое значение вводить). 
        // Объявим частную переменную-член типа int с именем "currentInputValue". 
        private int currentInputValue;

        // 4. Мы используем свойства get и set для переменной созданной на шаге 3. 
        // (Это значение должно быть доступно вне класса). Объявим свойство типа int с именем 
        // CurrentInput{}. Используем get и set для возврата переменной-члена "currentInputValue" 
        // Используем оператор set чтобы задать значение переменной "currentInputValue" значению 
        // value которое будет установлено. 
        public int CurrentInput
        {
            get { return currentInputValue; }
            set { currentInputValue = value; }
        }

        // 5. Создаем конструктор по умолчанию. Передаём переменную типа Entity с именем ent. 
        // Унаследуем от базового класса и передаём ent в конструктор базового класса. 
        public MyCircleJig(Entity ent)
            : base(ent)
        {

        }

        // 6. Переопределим функцию Sampler. Используем ключевое слово protected и возвращать она должна
        // Autodesk.AutoCAD.EditorInput.SamplerStatus. 
        // Используем Autodesk.AutoCAD.EditorInput.JigPrompts
        // в качестве единственного аргумента с именем "prompts" 
        // Заметка: поместим “}” после шага 29.
        protected override Autodesk.AutoCAD.EditorInput.SamplerStatus Sampler(Autodesk.AutoCAD.EditorInput.JigPrompts prompts)
        {

            // 7. (Этот шаг внутри функции Sampler) Создаём оператор switch. 
            // В качестве проверяемого значения используем currentInputValue, 
            // Заметка: Перенесём “}” после шага 28.
            switch (currentInputValue)
            {

                // 8. Используем  0 (ноль) для case. (получаем центр окружности) 
                case 0:

                    // 9. Объявим переменную с именем oldPnt типа Point3d и присвоим ей значение 
                    // переменной centerPoint. Она будет использована для проверки 
                    // сдвинулся ли курсор в jig. Если пользователь ничего не изменил
                    // последовательные вызовы функций Sampler и, 
                    // и Update, будет приводить к мерцанию на экране
                    // если не сделать этой проверки. 
                    Point3d oldPnt = centerPoint;

                    // 10. Объявим переменную типа PromptPointResult. Назовём её 
                    // jigPromptResult. Присвоим ей значение, возвращаемое методом 
                    // AcquirePoint с параметром типа JigPrompts переданным в функцию. 
                    // Используем строку "Pick center point : " в качестве аргумента message. 
                    PromptPointResult jigPromptResult = prompts.AcquirePoint("Pick center point : ");

                    // 11. Проверим Status переменной типа PromptPointResult, созданной на шаге 10. Используем 
                    // свойство Status и проверим равно ли оно PromptStatus.OK в операторе "if" 
                    // Заметка: Поместим “}” после шага 14.
                    if (jigPromptResult.Status == PromptStatus.OK)
                    {

                        // 12. Присвоим переменной centerPoint значение свойства Value 
                        // объекта PromptPointResult, созданного на шаге 10 
                        centerPoint = jigPromptResult.Value;

                        // 13. Проверим сместился ли курсор. Используем оператор "if". 
                        // Проверку делаем при помощи свойства DistanceTo переменной типа Point3d, 
                        // созданной на шаге 9. В качестве аргумента Point3d используем переменную centerPoint. 
                        // Используем оператор меньше ("<") и сравниваем его с 0.0001 
                        // Заметка: поместим “}” после шага 14 
                        if (oldPnt.DistanceTo(centerPoint) < 0.001)
                        {
                            // 14. Если мы здесь, значит курсор не сместился 
                            // возвращаем SamplerStatus.NoChange 
                            return SamplerStatus.NoChange;
                        }
                    }

                    // 15. Если мы здесь, значит курсор сместился 
                    // так что вернём  SamplerStatus.OK 
                    return SamplerStatus.OK;

                // 16. Используем 1 в case. (получим радиус окружности) 
                case 1:

                    // 17. Объявим переменную с именем oldRadius типа double и присвоим ей значение 
                    // равное переменной-члену radius. Мы ею воспользуемся для проверки сдвинулся 
                    // ли курсор в jig при запросе радиуса. 
                    double oldRadius = radius;

                    // 18. Объявим переменную типа JigPromptDistanceOptions. Назовём её jigPromptDistanceOpts. 
                    // Присвоим ей значение равное new JigPromptDistanceOptions. 
                    // В качестве аргумента message используем строку "Pick radius : " 
                    JigPromptDistanceOptions jigPromptDistanceOpts = new JigPromptDistanceOptions("Pick radius : ");

                    // 19. Присвоим свойству UseBasePoint переменной типа JigPromptDistanceOptions 
                    // созданной на шаге 18 в true 
                    jigPromptDistanceOpts.UseBasePoint = true;

                    // 20. Присвоим свойству BasePoint объекта JigPromptDistanceOptions 
                    // созданного на шаге 18 значение переменной-члена centerPoint 
                    jigPromptDistanceOpts.BasePoint = centerPoint;

                    // 21. Теперь готовы к вводу. Объявим переменную типа PromptDoubleResult. 
                    // с именем "jigPromptDblResult". Присвоим ей значение, которое 
                    // вернёт метод AcquireDistance, с параметром JigPrompts, 
                    // переданная в функцию Sampler. 
                    // Передаём переменную JigPromptDistanceOptions, объявленную на шаге 18. 
                    PromptDoubleResult jigPromptDblResult = prompts.AcquireDistance(jigPromptDistanceOpts);


                    // 22. Проверим Status переменной PromptDoubleResult, созданной на шаге 21. 
                    // Используем свойство Status и поверяем равно ли оно PromptStatus.OK в операторе "if" 
                    // Заметка: поместим “}” после шага 27 
                    if (jigPromptDblResult.Status == PromptStatus.OK)
                    {
                        // 23. Присвоим переменной-члену radius значение свойства Value 
                        // объекта типа PromptDoubleResult созданного на шаге 21 
                        radius = jigPromptDblResult.Value;


                        // 24. Проверим не слишком ли мал радиус. Используем оператор "if". 
                        // Используем метод System.Math.Abs() В качестве аргумента Double используем 
                        // переменную-член radius. Используем оператор меньше ("<") и сравниваем с 0.1 
                        // Заметка: поместим “}” после шага 25 
                        if (System.Math.Abs(radius) < 0.1)
                        {
                            // 25. Присвоим переменной-члену radius значение 1. Это будет 
                            // произвольное значение чтобы не дать окружности стать слишком маленькой 
                            radius = 1;
                        }

                        // 26. Проверим переместился ли курсор. Используем оператор "if" 
                        // Для проверки используем метод System.Math.Abs(). В качестве аргумента 
                        // вычтем из переменной-члена radius значение oldRadius. 
                        // Используем оператор меньше ("<") и сравниваем с 0.001 
                        // Заметка: поместим “}” после шага 27 
                        if (System.Math.Abs(oldRadius - radius) < 0.001)
                        {
                            // 27. Если мы попали сюда, значит курсор не переместился 
                            // Вернем SamplerStatus.NoChange 
                            return SamplerStatus.NoChange;
                        }
                    }

                    // 28. Если мы здесь, значит курсор переместился
                    // Вернём SamplerStatus.OK 
                    return SamplerStatus.OK;
            }
            // 29. Вернём SamplerSataus.NoChange. Сюда мы никогда не попадём
            // Просто предотвращаем сообщение об ошибке компилятора
            return SamplerStatus.NoChange;
        }

        // 30. Переопределяем функцию Update. Используем ключевое слово protected. 
        // Эта функция возвращает boolean и не имеет аргументов 
        // Заметка: поместим “}” после шага 38
        protected override bool Update()
        {

            // 31. В этой функции (Update) для каждого ввода, мы должны 
            // обновлять примитив. Создадим оператор switch. В качестве проверяемой переменной
            // используем переменную-член currentInputValue 
            // Заметка: Перенесём “}” после шага 37. 

            switch (currentInputValue)
            {
                // 32. Используем 0 (ноль) в качестве case. (Обновляем центр окружности) 
                case 0:

                    // 33. jig хранит окружность как объект типа Entity. Приведем его к типу Circle 
                    // так что бы было проще получить доступ к свойствам.
                    // Используем this.Entity и для приведения 
                    // используем класс Circle. Присваиваем свойству Center значение 
                    // равное переменной-члену centerPoint 
                    ((Circle)this.Entity).Center = centerPoint;

                    // 34. Покидаем оператор switch (break;)
                    break;

                // 35. Используем 1 для case. (Обновим радиус окружности) 
                case 1:

                    // 36. jig хранит окружность как объект типа Entity. Приведем его к типу Circle 
                    // так что бы было проще получить доступ к свойствам.
                    // Используем this.Entity и для приведения 
                    // используем класс Circle. Присваиваем свойству Radius значение 
                    // равное переменной-члену radius
                    ((Circle)this.Entity).Radius = radius;

                    // 37. Покидаем оператор switch (break;)
                    break;

            }

            // 38. Возвращаем true. 
            // Заметка: продолжим на шаге 39 (выше) в функции circleJig
            return true;
        }
 
    }

}