﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.EditorInput;
//using Autodesk.AutoCAD.DatabaseServices;

//using Autodesk.AutoCAD.Windows;
//using Autodesk.AutoCAD.Runtime;

namespace Lab8_Complete
{
    public partial class UserControl1 : UserControl
    {
        public UserControl1()
        {
            InitializeComponent();

            // 38. Чтобы определить, когда происходит событие перетаскивания, зарегистрируем 
            // событие MouseMove объекта DragLabel. (DragLabel.MouseMove) Используем += 
            // и оператор new для создания System.Windows.Forms.MouseEventHandler
            // В качестве параметра object используем имя функции, которую мы создадим на шагах 39-41.
            DragLabel.MouseMove += new System.Windows.Forms.MouseEventHandler(DragLabel_MouseMove);
        }

        // 39. Создаём функцию (private void) с именем DragLabel_MouseMove. Она должна иметь
        // два параметра - первый object, второй System.Windows.Forms.MouseEventArgs.
        // Имя объекта: sender, а MouseEventArgs: e
        // Заметка: Поместим “}” после шага 41 
        private void DragLabel_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
        {
            // 40. Недостаточно знать, что происходит операция перемещения мыши. 
            // Нам нужно еще знать, что нажата левая клавиша мыши 
            // Используем оператор "if". Для проверки нажатия левой кнопки мыши 
            // используем: System.Windows.Forms.Control.MouseButtons == System.Windows.Forms.MouseButtons.Left 
            // Поместим “}” после шага 31. 
            if (System.Windows.Forms.Control.MouseButtons == System.Windows.Forms.MouseButtons.Left)
                {

                    // 41. (Добавим ссылку на Windowsbase). 
                    // Это необходимо для System.Windows.DependencyObject() 
                    // Вызываем метод DoDragDrop объекта Application. В качестве параметра source 
                    // используем ключевое слово "this". В качестве параметра data тоже используем "this". 
                    // В качестве допустимых эффектов используем System.Windows.Forms.DragDropEffects.All 
                    // В качестве параметра Target используем оператор new и класс MyDropTarget 
                    // Этот шаг мы создадим на шагах 42-48. Класс DropTarget является для класса
                    // MyDropTarget базовым

                    Autodesk.AutoCAD.ApplicationServices.Application.DoDragDrop(this, this, System.Windows.Forms.DragDropEffects.All, new MyDropTarget()); 
                } 
            }

        private void DragLabel_Click(object sender, EventArgs e)
        {

        } 

    }
    // 42. Здесь мы создадим новый класс, который определит когда объект 
    // "отпустили" в редактор AutoCAD. Добавим новый public класс с именем 
    // MyDropTarget к проекту. Класс наследует Autodesk.AutoCAD.Windows.DropTarget. 
    // (имя должно совпадать с именем на шаге 41) 
    // Заметка: Поместим “}” после шага 48 
    public class MyDropTarget : Autodesk.AutoCAD.Windows.DropTarget
    {

        // 43. Переопределим функцию OnDrop. (Используем public override void) 
        // В качестве параметра используем "System.Windows.Forms.DragEventArgs e" 
        public override void OnDrop(System.Windows.Forms.DragEventArgs e)
        {
            // 44. Объявим переменную типа Editor. Присваиваем ей значение равное 
            // Application.DocumentManager.MdiActiveDocument.Editor 
            Editor ed = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Editor;

            // 45. Добавим блок try/catch. 
            // Заметка: Поместим “}” после шага 47.
            // после этого поместим catch и “}” после шага 48 
            try
            {
                // 46. Используем оператор using и объявим переменную DocumentLock с именем 
                // docLock. Присвоим ей значение: 
                // Application.DocumentManager.MdiActiveDocument.LockDocument() 
                // Заметка: Поместим “}” после шага 47. 
                // Создание переменной приводит к блокировке документа,
                // а её освобождение приводит к разблокировке.
                using (DocumentLock docLock = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.LockDocument())
                {
                    // 47. Выполним команду AddAnEnt из lab 4. Необходимо задать полное имя 
                    // с пространством имён и классом. (Lab8.adskClass.) 
                    // Lab8_Complete.adskClass.AddAnEnt();
                    ed.Document.SendStringToExecute("AddAnEnt ", true, false, true);
                }
            }
            catch (System.Exception ex)
            {
                // 48. Добавим  System.Exception ex к оператору catch 
                // Используем переменную класса Editor, созданную на шаге 42, для печати сообщения 
                // Если что-то пошло не так. Используем строку в качестве параметра message: 
                // "Error Handling OnDrop: " + ex.Message 
                ed.WriteMessage("Error Handling OnDrop: " + ex.Message);
            }

            // Это конец Lab8. Запустим AutoCAD, загрузимe dll and выполним команду 
            // Palette. Перетащим метку в область чертежа. 
            // Команда AddAnEnd должна запуститься, когда вы отпустите мышку.
        }
    } 
}
