﻿Imports Autodesk.AutoCAD.ApplicationServices
Imports Autodesk.AutoCAD.EditorInput
Imports Autodesk.AutoCAD.DatabaseServices

'Imports Autodesk.AutoCAD.Windows
Imports Autodesk.AutoCAD.Runtime


Public Class UserControl1

    Private Sub DragLabel_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles DragLabel.MouseMove


        ' 38. Этого достаточно для того, чтобы мы знали, что операция перемещения мыши
        ' имела место. Мы пойдем дальше и убедимся, что левая кнопка мыши была нажата 
        ' Используем оператор "If Then" для проверки того, была ли нажата левая кнопка мыши
        ' используем сравнение System.Windows.Forms.Control.MouseButtons = System.Windows.Forms.MouseButtons.Left
        ' Помещаем "End If" после шага 39.

        If (System.Windows.Forms.Control.MouseButtons = System.Windows.Forms.MouseButtons.Left) Then

            ' 39. (Должна быть добавлена ссылка на WindowsBase).
            ' Это необходимо для System.Windows.DependencyObject()
            ' Вызываем метод DoDragDrop объекта Application. В качестве параметра source
            ' мы используем ключевое слово "Me". В качестве параметра data так же используем "Me" 
            ' В качестве допустимых эффектов используем System.Windows.Forms.DragDropEffects.All
            ' В качестве параметра Target (цель) используем оператор New с именем класса "MyDropTarget"
            ' Этот класс создадим на шагах 40-46. Класс DropTarget является для класса MyDropTarget базовым.
            Application.DoDragDrop(Me, Me, System.Windows.Forms.DragDropEffects.All, New MyDropTarget())

        End If
    End Sub


    Private Sub DragLabel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DragLabel.Click

    End Sub

    Private Sub TreeView1_AfterSelect(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles TreeView1.AfterSelect

    End Sub
End Class

' 40. Здесь мы создадим новый класс, который определит когда объект <отпустили> 
' в редактор AutoCAD. Добавим класс с именем MyDropTarget, наследуемый от
' Autodesk.AutoCAD.Windows.DropTarget, к проекту. (имя должно совпадать с тем
' которое мы использовали на шаге 39).
' Заметка: Поместим "End Class" после шага 46

Public Class MyDropTarget
    Inherits Autodesk.AutoCAD.Windows.DropTarget

    ' 41. Переопределим процедуру OnDrop. (Используем Public Overrides). В качестве параметра
    ' используем "ByVal e As System.Windows.Forms.DragEventArgs"
    Public Overrides Sub OnDrop(ByVal e As System.Windows.Forms.DragEventArgs)
        ' 42. Объявим переменную типа Editor. Присваиваем ей значение 
        ' равное Application.DocumentManager.MdiActiveDocument.Editor
        Dim ed As Editor = Application.DocumentManager.MdiActiveDocument.Editor

        ' 43. Добавляем блок Try/Catch/Finally. 
        ' Заметка: Поместим Catch после шага 45, а End Try после шага 46
        Try
            ' 44. Используем оператор Using и объявим переменную типа DocumentLock 
            ' с именем docLock. Присвоим ей значение:
            ' Application.DocumentManager.MdiActiveDocument.LockDocument()
            ' Заметка: Поместим "End Using" после шага 45. Созданная переменная управляет
            ' блокировкой/разблокировкой документа. 
            Using docLock As DocumentLock = Application.DocumentManager.MdiActiveDocument.LockDocument()
                ' 45. Выполним процедуру AddAnEnt из lab 4. Требуется 
                ' дать полное квалификационное имя с классом. (adskClass.AddAnEnt())
                ' Примечание: так adskClass.AddAnEnt() не пойдёт, т.к. эта функция не статическая
                ed.Document.SendStringToExecute("AddAnEnt ", True, False, True)

            End Using

        Catch ex As System.Exception
            ' 46. Добавим 'ex as System.Exception' к оператору Catch
            ' Используем переменную класса Editor, созданную на шаге 42, чтобы вывести 
            ' сообщение пользователю. Если у нас что-то не так, тогда параметром будет
            ' "Error Handling OnDrop: " + ex.Message
            ed.WriteMessage("Error Handling OnDrop: " + ex.Message)

            ' Заметим, что это конец Lab8. Запустим AutoCAD, загрузим dll-файл и выполним 
            ' команду Palette. Перенесём метку в область чертежа. При этом должна запустится команда
            ' AddAnEnd, когда вы отпустите мышку.
        End Try

    End Sub
End Class
